function BBN_2(block)
% Level-2 MATLAB file S-Function for times two demo.
%   Copyright 1990-2009 The MathWorks, Inc.

  setup(block);
  
%endfunction

function setup(block)
  
  %% Register number of input and output ports
  block.NumInputPorts  = 1;
  block.NumOutputPorts = 1;

  %% Setup functional port properties to dynamically
  %% inherited.
  block.SetPreCompInpPortInfoToDynamic;
  block.SetPreCompOutPortInfoToDynamic;
  
  
  block.InputPort(1).Dimensions = 22;
  block.OutputPort(1).Dimensions = 1;

  block.InputPort(1).DirectFeedthrough = true;
  
  %% Set block sample time to inherited
  block.SampleTimes = [-1 0];
  
  %% Set the block simStateCompliance to default (i.e., same as a built-in block)
  block.SimStateCompliance = 'DefaultSimState';

  %% Run accelerator on TLC
  block.SetAccelRunOnTLC(true);
  
  %% Register methods
  block.RegBlockMethod('Outputs',                 @Output);  
  
%endfunction

function Output(block)

%% current
  if block.InputPort(1).Data(1) >= 0.5
      current = 'High';
  end
  if block.InputPort(1).Data(1) > 0 && block.InputPort(1).Data(1) < 0.5
      current = 'Low';
  end
%% wind
  if block.InputPort(1).Data(2) >= 2
      wind = 'High';
  end
  if block.InputPort(1).Data(2) >0 && block.InputPort(1).Data(2) < 2
      wind = 'Low';
  end
  
%% waves
  if block.InputPort(1).Data(3) >= 3
      waves = 'Severe';
  end
  if block.InputPort(1).Data(3) >=1 && block.InputPort(1).Data(3) < 3
      waves = 'Low';
  end
  if block.InputPort(1).Data(3) >0 && block.InputPort(1).Data(3) < 1
      waves = 'Calm';
  end
%% weather level
  if block.InputPort(1).Data(4) == 1
      weather = 'Extreme';
  end
  if block.InputPort(1).Data(4) == -1
      weather = 'Not_extreme';
  end
%% camera
  if block.InputPort(1).Data(5) == 1
      camera = 'True';
  end
  if block.InputPort(1).Data(5) == -1
      camera = 'False';
  end
%% ops & maint.
  if block.InputPort(1).Data(6) == 1
      opmaint = 'True';
  end
  if block.InputPort(1).Data(6) == -1
      opmaint = 'False';
  end
%% power
  if block.InputPort(1).Data(7) == 1
      nopower = 'True'; 
  end
  if block.InputPort(1).Data(7) == -1
      nopower = 'False';
  end  
%% VSP1
  if block.InputPort(1).Data(8) == 1
      VSP1 = 'True';
  end
  if block.InputPort(1).Data(8) == -1
      VSP1 = 'False';
  end
%% VSP2
  if block.InputPort(1).Data(9) == 1
      VSP2 = 'True';
  end
  if block.InputPort(1).Data(9) == -1
      VSP2 = 'False';
  end 
%% bow thrustuer
  if block.InputPort(1).Data(10) == 1
      BT = 'True';
  end
  if block.InputPort(1).Data(10) == -1
      BT = 'False';
  end     
%% maneuverability
  if block.InputPort(1).Data(11) == 1
      man = 'True';
  end
  if block.InputPort(1).Data(11) == -1
      man = 'False';
  end  
%% pos. reference
  if block.InputPort(1).Data(12) == 1
      posref = 'True';
  end
  if block.InputPort(1).Data(12) == -1
      posref = 'False';
  end 
%% pos. loss
  if block.InputPort(1).Data(13) == 1
      pos = 'True';
  end
  if block.InputPort(1).Data(13) == -1
      pos = 'False';
  end 
%% operator
  if block.InputPort(1).Data(14) == 1
      op = 'True';
  end
  if block.InputPort(1).Data(14) == -1
      op = 'False';
  end   

%% AIS
  if block.InputPort(1).Data(15) == 1
      AIS = 'True';
  end
  if block.InputPort(1).Data(15) == -1
      AIS = 'False';
  end   
%% object
  if block.InputPort(1).Data(16) == 1
      objnb = 'True';
  end
  if block.InputPort(1).Data(16) == -1
      objnb = 'False';
  end 
%% radar    
  if block.InputPort(1).Data(17) == 1
      radar = 'True';
  end
  if block.InputPort(1).Data(17) == -1
      radar = 'False';
  end
%% navigation eq.    
  if block.InputPort(1).Data(18) == 1
      navig = 'True';
  end
  if block.InputPort(1).Data(18) == -1
      navig = 'False';
  end  
%% situation awareness   
  if block.InputPort(1).Data(19) == 1
      sitaw = 'True';
  end
  if block.InputPort(1).Data(19) == -1
      sitaw = 'False';
  end  
%% drone   
  if block.InputPort(1).Data(20) == 1
      drone = 'True';
  end
  if block.InputPort(1).Data(20) == -1
      drone = 'False';
  end 
%% situation awareness operator   
  if block.InputPort(1).Data(21) == 1
      sitawop = 'True';
  end
  if block.InputPort(1).Data(21) == -1
      sitawop = 'False';
  end   
%% situation awareness system 
  if block.InputPort(1).Data(22) == 1
      sitawsys = 'High_risk';
  end
  if block.InputPort(1).Data(22) == -1
      sitawsys = 'Low_risk';
  end 


  
  BBN_sim

  P_collision = net.getNodeValue(22);
 
  block.OutputPort(1).Data = P_collision(1);
  
%endfunction

