clear obj net      % Clear java objects to avoid warning
javaaddpath('C:\Users\MCLab\Desktop\smile')   % Add location of smileInit.class
% Initialize smile license

obj = smileInit();
try
    obj.main('')
catch
end
disp('License OK')
%Check that SMILE is loaded to path
try
    obj.initGenieNetwork();
catch ME
    msg = ['Unable to access SMILE.\n' ...
           'Ensure that the full path of jsmile-i.i.i.jar is added to classpath.txt'];
    causeException = MException('MATLAB:myCode:dimensions',msg);
    ME = addCause(ME,causeException);
    rethrow(ME);
end
disp('SMILE OK')

% Create net object and read from file
net = obj.initGenieNetwork();                       
net.readFile('BBN_05_06.xdsl');
net.updateBeliefs()


%% Set evidence
% Plot network in matlab

build_network(net)

% Set evidence and update plot
if exist('current', 'var')
    net.setEvidence('Current_velocity', current)
end

if exist('waves', 'var')
    net.setEvidence('Wave_height', waves)
end

if exist('wind', 'var')
    net.setEvidence('Wind_velocity', wind)
end

if exist('weather', 'var')
    net.setEvidence('Weather_level', weather)
end

if exist('camera', 'var')
    net.setEvidence('Camera_failure', camera)
end

if exist('opmaint', 'var')
    net.setEvidence('Insufficient_maintenance', opmaint)
end

if exist('nopower', 'var')
    net.setEvidence('Inadequate_power', nopower)
end

if exist('VSP1', 'var')
    net.setEvidence('Loss_of_VSP1', VSP1)
end

if exist('VSP2', 'var')
    net.setEvidence('Loss_of_VSP2', VSP2)
end

if exist('BT', 'var')
    net.setEvidence('Loss_of_bow_thruster', BT)
end

if exist('man', 'var')
    net.setEvidence('Loss_of_maneuverability', man)
end

if exist('posref', 'var')
    net.setEvidence('Position_reference_lost', posref)
end

if exist('pos', 'var')
    net.setEvidence('Loss_of_position', pos)
end

if exist('op', 'var')
    net.setEvidence('Communication_fails', op)
end

if exist('AIS', 'var')
    net.setEvidence('Loss_of_AIS', AIS)
end

if exist('objnb', 'var')
    net.setEvidence('Object_nearby', objnb)
end

if exist('radar', 'var')
    net.setEvidence('RADAR_failure', radar)
end

if exist('navig', 'var')
    net.setEvidence('NE_failure', navig)
end

if exist('sitaw', 'var')
    net.setEvidence('SA_vessel_lost', sitaw)
end

if exist('drone', 'var')
    net.setEvidence('Drone_failure', drone)
end

if exist('sitawop', 'var')
    net.setEvidence('SA_operator_lost', sitawop)
end

if exist('sitawsys', 'var')
    net.setEvidence('System_SA_lost', sitawsys)
end




net.updateBeliefs()
update_network(net)

