function update_network(net)
fig = findobj('Type', 'figure', 'Tag', 'bbn');
set(0, 'CurrentFigure', fig);
nodes = net.getAllNodeIds();
def_colors = get(0, 'defaultaxescolororder');
for i = 1:numel(nodes)
    
    node = nodes(i);
    switch net.getNodeType(node)
        case 18
            node_type = 'chance';
            outcomes = net.getOutcomeIds(node);
            beliefs = net.getNodeValue(node);
            
        case 4
            node_type = 'equation';
            outcomes = {'one','two'};
    end
    
    p = findobj('Type', 'uipanel', 'Tag', char(node));
    if net.isRealEvidence(node)
        p.ForegroundColor = def_colors(5,:);
    end
    
    switch node_type
        case 'chance'
            ax = p.Children;
            cla(ax)
            bar(ax, 1:numel(beliefs), beliefs, 'Horizontal', 'on')
            ax.XTick = [];
            for j = 1:numel(ax.YTick)
                ax.YTickLabels{j} = replace([char(outcomes(j)), ' ', num2str(beliefs(j)*100), '%'], '_', ' ');
            end
            ax.OuterPosition(3) = 1.1;
            axis(ax, 'tight')
            ax.XLim = [0 1];
            
        case 'equation'
            tb = p.Children;
            tb.String = num2str(net.getNodeValue(node));
    end
end
end