/*
 * ctrl_custom.c
 *
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * Code generation for model "ctrl_custom".
 *
 * Model version              : 1.290
 * Simulink Coder version : 8.11 (R2016b) 25-Aug-2016
 * C source code generated on : Tue May 28 15:35:16 2019
 *
 * Target selection: NIVeriStand_VxWorks.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: 32-bit Generic
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "ctrl_custom.h"
#include "ctrl_custom_private.h"

/* Block signals (auto storage) */
B_ctrl_custom_T ctrl_custom_B;

/* Continuous states */
X_ctrl_custom_T ctrl_custom_X;

/* Block states (auto storage) */
DW_ctrl_custom_T ctrl_custom_DW;

/* Real-time model */
RT_MODEL_ctrl_custom_T ctrl_custom_M_;
RT_MODEL_ctrl_custom_T *const ctrl_custom_M = &ctrl_custom_M_;

/*
 * This function updates continuous states using the ODE4 fixed-step
 * solver algorithm
 */
static void rt_ertODEUpdateContinuousStates(RTWSolverInfo *si )
{
  time_T t = rtsiGetT(si);
  time_T tnew = rtsiGetSolverStopTime(si);
  time_T h = rtsiGetStepSize(si);
  real_T *x = rtsiGetContStates(si);
  ODE4_IntgData *id = (ODE4_IntgData *)rtsiGetSolverData(si);
  real_T *y = id->y;
  real_T *f0 = id->f[0];
  real_T *f1 = id->f[1];
  real_T *f2 = id->f[2];
  real_T *f3 = id->f[3];
  real_T temp;
  int_T i;
  int_T nXc = 21;
  rtsiSetSimTimeStep(si,MINOR_TIME_STEP);

  /* Save the state values at time t in y, we'll use x as ynew. */
  (void) memcpy(y, x,
                (uint_T)nXc*sizeof(real_T));

  /* Assumes that rtsiSetT and ModelOutputs are up-to-date */
  /* f0 = f(t,y) */
  rtsiSetdX(si, f0);
  ctrl_custom_derivatives();

  /* f1 = f(t + (h/2), y + (h/2)*f0) */
  temp = 0.5 * h;
  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (temp*f0[i]);
  }

  rtsiSetT(si, t + temp);
  rtsiSetdX(si, f1);
  ctrl_custom_output();
  ctrl_custom_derivatives();

  /* f2 = f(t + (h/2), y + (h/2)*f1) */
  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (temp*f1[i]);
  }

  rtsiSetdX(si, f2);
  ctrl_custom_output();
  ctrl_custom_derivatives();

  /* f3 = f(t + h, y + h*f2) */
  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (h*f2[i]);
  }

  rtsiSetT(si, tnew);
  rtsiSetdX(si, f3);
  ctrl_custom_output();
  ctrl_custom_derivatives();

  /* tnew = t + h
     ynew = y + (h/6)*(f0 + 2*f1 + 2*f2 + 2*f3) */
  temp = h / 6.0;
  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + temp*(f0[i] + 2.0*f1[i] + 2.0*f2[i] + f3[i]);
  }

  rtsiSetSimTimeStep(si,MAJOR_TIME_STEP);
}

/*
 * Output and update for atomic system:
 *    '<Root>/NED -> BODY1'
 *    '<S9>/NED -> BODY'
 *    '<S9>/NED -> BODY1'
 */
void ctrl_custom_NEDBODY1(const real_T rtu_u[3], real_T rtu_psi,
  B_NEDBODY1_ctrl_custom_T *localB)
{
  static const int8_T b[3] = { 0, 0, 1 };

  real_T tmp[9];
  int32_T i;

  /* MATLAB Function 'NED -> BODY1': '<S8>:1' */
  /* '<S8>:1:4' */
  /* '<S8>:1:2' */
  /* '<S8>:1:5' */
  tmp[0] = cos(rtu_psi);
  tmp[1] = -sin(rtu_psi);
  tmp[2] = 0.0;
  tmp[3] = sin(rtu_psi);
  tmp[4] = cos(rtu_psi);
  tmp[5] = 0.0;
  for (i = 0; i < 3; i++) {
    tmp[6 + i] = b[i];
    localB->y[i] = 0.0;
    localB->y[i] += tmp[i] * rtu_u[0];
    localB->y[i] += tmp[i + 3] * rtu_u[1];
    localB->y[i] += tmp[i + 6] * rtu_u[2];
  }
}

real_T rt_atan2d_snf(real_T u0, real_T u1)
{
  real_T y;
  int32_T u0_0;
  int32_T u1_0;
  if (rtIsNaN(u0) || rtIsNaN(u1)) {
    y = (rtNaN);
  } else if (rtIsInf(u0) && rtIsInf(u1)) {
    if (u0 > 0.0) {
      u0_0 = 1;
    } else {
      u0_0 = -1;
    }

    if (u1 > 0.0) {
      u1_0 = 1;
    } else {
      u1_0 = -1;
    }

    y = atan2(u0_0, u1_0);
  } else if (u1 == 0.0) {
    if (u0 > 0.0) {
      y = RT_PI / 2.0;
    } else if (u0 < 0.0) {
      y = -(RT_PI / 2.0);
    } else {
      y = 0.0;
    }
  } else {
    y = atan2(u0, u1);
  }

  return y;
}

/* Model output function */
void ctrl_custom_output(void)
{
  /* local block i/o variables */
  real_T rtb_Derivative1[3];
  real_T rtb_MatrixMultiply1[3];
  real_T (*lastU)[3];
  real_T lastTime;
  real_T u[5];
  static const real_T a[15] = { 0.48543689320388345, 0.0, 0.4854368932038835,
    0.0, 0.0, -0.0091902893854672, 0.22203968540691685, 0.0091902893854671989,
    0.22203968540691688, 0.20638959606761159, 0.048613648345453023,
    -0.57138494797595385, -0.048613648345453009, -0.57138494797595385,
    0.44771890179934026 };

  static const int8_T b[3] = { 0, 0, 1 };

  boolean_T y;
  real_T rtb_Multiply1[3];
  real_T rtb_Memory;
  real_T rtb_Memory1;
  real_T rtb_Memory2;
  int32_T i;
  real_T tmp[3];
  real_T tmp_0[3];
  real_T tmp_1[3];
  real_T tmp_2[9];
  real_T tmp_3[3];
  real_T tmp_4;
  boolean_T exitg1;
  if (rtmIsMajorTimeStep(ctrl_custom_M)) {
    /* set solver stop time */
    if (!(ctrl_custom_M->Timing.clockTick0+1)) {
      rtsiSetSolverStopTime(&ctrl_custom_M->solverInfo,
                            ((ctrl_custom_M->Timing.clockTickH0 + 1) *
        ctrl_custom_M->Timing.stepSize0 * 4294967296.0));
    } else {
      rtsiSetSolverStopTime(&ctrl_custom_M->solverInfo,
                            ((ctrl_custom_M->Timing.clockTick0 + 1) *
        ctrl_custom_M->Timing.stepSize0 + ctrl_custom_M->Timing.clockTickH0 *
        ctrl_custom_M->Timing.stepSize0 * 4294967296.0));
    }
  }                                    /* end MajorTimeStep */

  /* Update absolute time of base rate at minor time step */
  if (rtmIsMinorTimeStep(ctrl_custom_M)) {
    ctrl_custom_M->Timing.t[0] = rtsiGetT(&ctrl_custom_M->solverInfo);
  }

  /* Integrator: '<S9>/Integrator' */
  ctrl_custom_B.Integrator[0] = ctrl_custom_X.Integrator_CSTATE[0];

  /* Integrator: '<S12>/Integrator2' */
  ctrl_custom_B.Integrator2[0] = ctrl_custom_X.Integrator2_CSTATE[0];

  /* Integrator: '<S9>/Integrator' */
  ctrl_custom_B.Integrator[1] = ctrl_custom_X.Integrator_CSTATE[1];

  /* Integrator: '<S12>/Integrator2' */
  ctrl_custom_B.Integrator2[1] = ctrl_custom_X.Integrator2_CSTATE[1];

  /* Integrator: '<S9>/Integrator' */
  ctrl_custom_B.Integrator[2] = ctrl_custom_X.Integrator_CSTATE[2];

  /* Integrator: '<S12>/Integrator2' */
  ctrl_custom_B.Integrator2[2] = ctrl_custom_X.Integrator2_CSTATE[2];
  if (rtmIsMajorTimeStep(ctrl_custom_M)) {
  }

  /* Integrator: '<S9>/Integrator2' */
  ctrl_custom_B.Integrator2_m[0] = ctrl_custom_X.Integrator2_CSTATE_k[0];
  ctrl_custom_B.Integrator2_m[1] = ctrl_custom_X.Integrator2_CSTATE_k[1];
  ctrl_custom_B.Integrator2_m[2] = ctrl_custom_X.Integrator2_CSTATE_k[2];

  /* Derivative: '<Root>/Derivative1' */
  if ((ctrl_custom_DW.TimeStampA >= ctrl_custom_M->Timing.t[0]) &&
      (ctrl_custom_DW.TimeStampB >= ctrl_custom_M->Timing.t[0])) {
    rtb_Derivative1[0] = 0.0;
    rtb_Derivative1[1] = 0.0;
    rtb_Derivative1[2] = 0.0;
  } else {
    lastTime = ctrl_custom_DW.TimeStampA;
    lastU = (real_T (*)[3])ctrl_custom_DW.LastUAtTimeA;
    if (ctrl_custom_DW.TimeStampA < ctrl_custom_DW.TimeStampB) {
      if (ctrl_custom_DW.TimeStampB < ctrl_custom_M->Timing.t[0]) {
        lastTime = ctrl_custom_DW.TimeStampB;
        lastU = (real_T (*)[3])ctrl_custom_DW.LastUAtTimeB;
      }
    } else {
      if (ctrl_custom_DW.TimeStampA >= ctrl_custom_M->Timing.t[0]) {
        lastTime = ctrl_custom_DW.TimeStampB;
        lastU = (real_T (*)[3])ctrl_custom_DW.LastUAtTimeB;
      }
    }

    lastTime = ctrl_custom_M->Timing.t[0] - lastTime;
    rtb_Derivative1[0] = (ctrl_custom_B.x_m - (*lastU)[0]) / lastTime;
    rtb_Derivative1[1] = (ctrl_custom_B.y_m - (*lastU)[1]) / lastTime;
    rtb_Derivative1[2] = (ctrl_custom_B.psi_m - (*lastU)[2]) / lastTime;
  }

  /* End of Derivative: '<Root>/Derivative1' */

  /* MATLAB Function: '<Root>/NED -> BODY1' */
  ctrl_custom_NEDBODY1(rtb_Derivative1, ctrl_custom_B.psi_m,
                       &ctrl_custom_B.sf_NEDBODY1);

  /* Saturate: '<S12>/Saturation8' incorporates:
   *  Integrator: '<S12>/Integrator1'
   */
  if (ctrl_custom_X.Integrator1_CSTATE[2] > ctrl_custom_P.Saturation8_UpperSat)
  {
    ctrl_custom_B.Saturation8 = ctrl_custom_P.Saturation8_UpperSat;
  } else if (ctrl_custom_X.Integrator1_CSTATE[2] <
             ctrl_custom_P.Saturation8_LowerSat) {
    ctrl_custom_B.Saturation8 = ctrl_custom_P.Saturation8_LowerSat;
  } else {
    ctrl_custom_B.Saturation8 = ctrl_custom_X.Integrator1_CSTATE[2];
  }

  /* End of Saturate: '<S12>/Saturation8' */

  /* Saturate: '<S12>/Saturation6' incorporates:
   *  Integrator: '<S12>/Integrator1'
   */
  if (ctrl_custom_X.Integrator1_CSTATE[0] > ctrl_custom_P.Saturation6_UpperSat)
  {
    ctrl_custom_B.Saturation6 = ctrl_custom_P.Saturation6_UpperSat;
  } else if (ctrl_custom_X.Integrator1_CSTATE[0] <
             ctrl_custom_P.Saturation6_LowerSat) {
    ctrl_custom_B.Saturation6 = ctrl_custom_P.Saturation6_LowerSat;
  } else {
    ctrl_custom_B.Saturation6 = ctrl_custom_X.Integrator1_CSTATE[0];
  }

  /* End of Saturate: '<S12>/Saturation6' */

  /* Saturate: '<S12>/Saturation7' incorporates:
   *  Integrator: '<S12>/Integrator1'
   */
  if (ctrl_custom_X.Integrator1_CSTATE[1] > ctrl_custom_P.Saturation7_UpperSat)
  {
    ctrl_custom_B.Saturation7 = ctrl_custom_P.Saturation7_UpperSat;
  } else if (ctrl_custom_X.Integrator1_CSTATE[1] <
             ctrl_custom_P.Saturation7_LowerSat) {
    ctrl_custom_B.Saturation7 = ctrl_custom_P.Saturation7_LowerSat;
  } else {
    ctrl_custom_B.Saturation7 = ctrl_custom_X.Integrator1_CSTATE[1];
  }

  /* End of Saturate: '<S12>/Saturation7' */

  /* Integrator: '<S9>/Integrator1' */
  ctrl_custom_B.Integrator1[0] = ctrl_custom_X.Integrator1_CSTATE_c[0];
  ctrl_custom_B.Integrator1[1] = ctrl_custom_X.Integrator1_CSTATE_c[1];
  ctrl_custom_B.Integrator1[2] = ctrl_custom_X.Integrator1_CSTATE_c[2];

  /* Sum: '<Root>/Sum1' */
  lastTime = ctrl_custom_B.Integrator[0] - ctrl_custom_B.Integrator2[0];

  /* Fcn: '<S25>/Fcn' */
  tmp_4 = lastTime;

  /* Sum: '<Root>/Sum1' */
  rtb_Multiply1[0] = lastTime;
  lastTime = ctrl_custom_B.Integrator[1] - ctrl_custom_B.Integrator2[1];

  /* SignalConversion: '<S1>/TmpSignal ConversionAtMultiply1Inport2' incorporates:
   *  Fcn: '<S25>/Fcn'
   *  Fcn: '<S25>/Fcn1'
   *  Sum: '<Root>/Sum1'
   */
  ctrl_custom_B.TmpSignalConversionAtMultiply1I[0] = cos
    (ctrl_custom_B.Integrator[2]) * tmp_4 + sin(ctrl_custom_B.Integrator[2]) *
    lastTime;
  ctrl_custom_B.TmpSignalConversionAtMultiply1I[1] = -sin
    (ctrl_custom_B.Integrator[2]) * rtb_Multiply1[0] + cos
    (ctrl_custom_B.Integrator[2]) * lastTime;
  ctrl_custom_B.TmpSignalConversionAtMultiply1I[2] = ctrl_custom_B.Integrator[2]
    - ctrl_custom_B.Integrator2[2];

  /* SignalConversion: '<S12>/TmpSignal ConversionAtGain14Inport1' */
  ctrl_custom_B.TmpSignalConversionAtGain14Inpo[0] = ctrl_custom_B.Saturation6;
  ctrl_custom_B.TmpSignalConversionAtGain14Inpo[1] = ctrl_custom_B.Saturation7;
  ctrl_custom_B.TmpSignalConversionAtGain14Inpo[2] = ctrl_custom_B.Saturation8;
  for (i = 0; i < 3; i++) {
    /* Sum: '<S1>/Sum6' incorporates:
     *  Constant: '<S1>/Constant24'
     *  Product: '<S1>/Multiply1'
     */
    tmp[i] = 0.0 - ((ctrl_custom_P.K_p[i + 3] *
                     ctrl_custom_B.TmpSignalConversionAtMultiply1I[1] +
                     ctrl_custom_P.K_p[i] *
                     ctrl_custom_B.TmpSignalConversionAtMultiply1I[0]) +
                    ctrl_custom_P.K_p[i + 6] *
                    ctrl_custom_B.TmpSignalConversionAtMultiply1I[2]);

    /* Sum: '<Root>/Sum4' incorporates:
     *  Product: '<S1>/Multiply2'
     */
    tmp_1[i] = ctrl_custom_B.Integrator1[i] -
      ctrl_custom_B.TmpSignalConversionAtGain14Inpo[i];

    /* Product: '<S1>/Multiply' incorporates:
     *  Constant: '<S1>/Constant25'
     *  Integrator: '<S1>/Integrator1'
     *  Sum: '<S1>/Sum6'
     */
    tmp_0[i] = ctrl_custom_P.K_i[i + 6] * ctrl_custom_X.Integrator1_CSTATE_b[2]
      + (ctrl_custom_P.K_i[i + 3] * ctrl_custom_X.Integrator1_CSTATE_b[1] +
         ctrl_custom_P.K_i[i] * ctrl_custom_X.Integrator1_CSTATE_b[0]);
  }

  /* Sum: '<S1>/Sum6' incorporates:
   *  Constant: '<S1>/Constant26'
   *  Product: '<S1>/Multiply2'
   */
  for (i = 0; i < 3; i++) {
    ctrl_custom_B.Sum6[i] = (tmp[i] - tmp_0[i]) - ((ctrl_custom_P.K_d[i + 3] *
      tmp_1[1] + ctrl_custom_P.K_d[i] * tmp_1[0]) + ctrl_custom_P.K_d[i + 6] *
      tmp_1[2]);
  }

  /* MATLAB Function: '<S11>/Rectangle coordinate thrust allocation ' */
  /* MATLAB Function 'Rectangle coordinate thrust allocation/Rectangle coordinate thrust allocation ': '<S36>:1' */
  /* '<S36>:1:13' */
  /*  Thruster configuration parameters */
  /*  VSP1 */
  /*  VSP2 */
  /*  BT */
  /*  Thruster gains */
  /*  Moore-Penrose pseudo-inverse */
  /* '<S36>:1:13' */
  for (i = 0; i < 5; i++) {
    u[i] = a[i + 10] * ctrl_custom_B.Sum6[2] + (a[i + 5] * ctrl_custom_B.Sum6[1]
      + a[i] * ctrl_custom_B.Sum6[0]);
  }

  /* '<S36>:1:15' */
  ctrl_custom_B.u_1 = u[4];

  /* BT */
  /* '<S36>:1:16' */
  /* VSP1 */
  /* '<S36>:1:17' */
  /* VSP2 */
  /* '<S36>:1:18' */
  ctrl_custom_B.alpha_1 = rt_atan2d_snf(u[1], u[0]);

  /* '<S36>:1:19' */
  ctrl_custom_B.alpha_2 = rt_atan2d_snf(u[3], u[2]);

  /* MATLAB Function: '<S11>/Rectangle coordinate thrust allocation ' */
  lastTime = sqrt(u[0] * u[0] + u[1] * u[1]);

  /* Saturate: '<S22>/Saturation11' */
  if (lastTime > ctrl_custom_P.Saturation11_UpperSat) {
    ctrl_custom_B.Saturation11 = ctrl_custom_P.Saturation11_UpperSat;
  } else if (lastTime < ctrl_custom_P.Saturation11_LowerSat) {
    ctrl_custom_B.Saturation11 = ctrl_custom_P.Saturation11_LowerSat;
  } else {
    ctrl_custom_B.Saturation11 = lastTime;
  }

  /* End of Saturate: '<S22>/Saturation11' */

  /* MATLAB Function: '<S11>/Rectangle coordinate thrust allocation ' */
  lastTime = sqrt(u[2] * u[2] + u[3] * u[3]);

  /* Saturate: '<S22>/Saturation1' */
  if (lastTime > ctrl_custom_P.Saturation1_UpperSat) {
    ctrl_custom_B.Saturation1 = ctrl_custom_P.Saturation1_UpperSat;
  } else if (lastTime < ctrl_custom_P.Saturation1_LowerSat) {
    ctrl_custom_B.Saturation1 = ctrl_custom_P.Saturation1_LowerSat;
  } else {
    ctrl_custom_B.Saturation1 = lastTime;
  }

  /* End of Saturate: '<S22>/Saturation1' */
  if (rtmIsMajorTimeStep(ctrl_custom_M)) {
  }

  if (rtmIsMajorTimeStep(ctrl_custom_M)) {
    /* Memory: '<S7>/Memory' */
    rtb_Memory = ctrl_custom_DW.Memory_PreviousInput;

    /* Memory: '<S7>/Memory1' */
    rtb_Memory1 = ctrl_custom_DW.Memory1_PreviousInput;

    /* Memory: '<S7>/Memory2' */
    rtb_Memory2 = ctrl_custom_DW.Memory2_PreviousInput;
    for (i = 0; i < 9; i++) {
      /* Gain: '<S9>/Gain' incorporates:
       *  Constant: '<S9>/Constant1'
       */
      ctrl_custom_B.Gain[i] = ctrl_custom_P.Gain_Gain[i] *
        ctrl_custom_P.Constant1_Value;

      /* Gain: '<S9>/Gain1' incorporates:
       *  Constant: '<S9>/Constant4'
       */
      ctrl_custom_B.Gain1[i] = ctrl_custom_P.Gain1_Gain[i] *
        ctrl_custom_P.Constant4_Value;

      /* Gain: '<S9>/Gain2' incorporates:
       *  Constant: '<S9>/Constant5'
       */
      ctrl_custom_B.Gain2[i] = ctrl_custom_P.Gain2_Gain[i] *
        ctrl_custom_P.Constant5_Value;
    }
  }

  /* MATLAB Function: '<S9>/NED -> BODY1' */
  /* MATLAB Function 'Observer with bias/BODY -> NED': '<S33>:1' */
  /* '<S33>:1:4' */
  /* '<S33>:1:2' */
  /* '<S33>:1:5' */
  ctrl_custom_NEDBODY1(ctrl_custom_B.Integrator2_m, ctrl_custom_B.psi_m,
                       &ctrl_custom_B.sf_NEDBODY1_m);
  if (rtmIsMajorTimeStep(ctrl_custom_M)) {
    /* SignalConversion: '<S18>/TmpSignal ConversionAt SFunction Inport2' incorporates:
     *  MATLAB Function: '<Root>/loss of signal 1'
     */
    rtb_Multiply1[0] = rtb_Memory;
    rtb_Multiply1[1] = rtb_Memory1;
    rtb_Multiply1[2] = rtb_Memory2;

    /* MATLAB Function: '<Root>/loss of signal 1' incorporates:
     *  UnitDelay: '<Root>/Unit Delay1'
     */
    /* MATLAB Function 'loss of signal 1': '<S18>:1' */
    /*  Init */
    /*  Update counter */
    y = true;
    i = 0;
    exitg1 = false;
    while ((!exitg1) && (i + 1 < 4)) {
      if (!(ctrl_custom_DW.UnitDelay1_DSTATE[i] == rtb_Multiply1[i])) {
        y = false;
        exitg1 = true;
      } else {
        i++;
      }
    }

    if (y) {
      /* '<S18>:1:12' */
      ctrl_custom_DW.counter++;
    } else {
      /* '<S18>:1:14' */
      ctrl_custom_DW.counter = 0.0;
    }

    /*  Make signal when we have 4 consecutive eta values  */
    if (ctrl_custom_DW.counter >= 4.0) {
      /* '<S18>:1:18' */
      /* '<S18>:1:19' */
      i = 0;

      /*  Loss-of-signal */
    } else {
      /* '<S18>:1:21' */
      i = 1;

      /*  Position signal available */
    }

    /* '<S18>:1:24' */
    /* '<S18>:1:25' */
    ctrl_custom_B.eta_out[0] = ctrl_custom_DW.UnitDelay1_DSTATE[0];
    ctrl_custom_B.eta_out[1] = ctrl_custom_DW.UnitDelay1_DSTATE[1];
    ctrl_custom_B.eta_out[2] = ctrl_custom_DW.UnitDelay1_DSTATE[2];

    /* Sum: '<S9>/Sum3' incorporates:
     *  Constant: '<S9>/Constant2'
     *  MATLAB Function: '<Root>/loss of signal 1'
     */
    ctrl_custom_B.Sum3 = ctrl_custom_P.Constant2_Value + (real_T)i;
  }

  /* MultiPortSwitch: '<S9>/Multiport Switch' incorporates:
   *  Constant: '<S9>/Constant3'
   *  Sum: '<S9>/Sum1'
   */
  switch ((int32_T)ctrl_custom_B.Sum3) {
   case 1:
    rtb_Multiply1[0] = ctrl_custom_P.Constant3_Value[0];
    rtb_Multiply1[1] = ctrl_custom_P.Constant3_Value[1];
    rtb_Multiply1[2] = ctrl_custom_P.Constant3_Value[2];
    break;

   case 2:
    rtb_Multiply1[0] = ctrl_custom_B.x_m - ctrl_custom_B.Integrator[0];
    rtb_Multiply1[1] = ctrl_custom_B.y_m - ctrl_custom_B.Integrator[1];
    rtb_Multiply1[2] = ctrl_custom_B.psi_m - ctrl_custom_B.Integrator[2];
    break;

   default:
    rtb_Multiply1[0] = 0.0;
    rtb_Multiply1[1] = 0.0;
    rtb_Multiply1[2] = 0.0;
    break;
  }

  /* End of MultiPortSwitch: '<S9>/Multiport Switch' */

  /* Product: '<S9>/Matrix Multiply1' */
  for (i = 0; i < 3; i++) {
    rtb_MatrixMultiply1[i] = 0.0;
    rtb_MatrixMultiply1[i] += ctrl_custom_B.Gain2[i] * rtb_Multiply1[0];
    rtb_MatrixMultiply1[i] += ctrl_custom_B.Gain2[i + 3] * rtb_Multiply1[1];
    rtb_MatrixMultiply1[i] += ctrl_custom_B.Gain2[i + 6] * rtb_Multiply1[2];
  }

  /* End of Product: '<S9>/Matrix Multiply1' */

  /* MATLAB Function: '<S9>/NED -> BODY' */
  ctrl_custom_NEDBODY1(rtb_MatrixMultiply1, ctrl_custom_B.psi_m,
                       &ctrl_custom_B.sf_NEDBODY);

  /* Sum: '<S9>/Sum2' incorporates:
   *  Gain: '<S9>/D'
   *  Gain: '<S9>/M'
   */
  for (i = 0; i < 3; i++) {
    tmp[i] = ((ctrl_custom_B.sf_NEDBODY1_m.y[i] + ctrl_custom_B.sf_NEDBODY.y[i])
              + ctrl_custom_B.Sum6[i]) - ((ctrl_custom_P.D_Gain[i + 3] *
      ctrl_custom_B.Integrator1[1] + ctrl_custom_P.D_Gain[i] *
      ctrl_custom_B.Integrator1[0]) + ctrl_custom_P.D_Gain[i + 6] *
      ctrl_custom_B.Integrator1[2]);
  }

  /* End of Sum: '<S9>/Sum2' */

  /* MATLAB Function: '<S9>/BODY -> NED' */
  tmp_2[0] = cos(ctrl_custom_B.psi_m);
  tmp_2[3] = -sin(ctrl_custom_B.psi_m);
  tmp_2[6] = 0.0;
  tmp_2[1] = sin(ctrl_custom_B.psi_m);
  tmp_2[4] = cos(ctrl_custom_B.psi_m);
  tmp_2[7] = 0.0;
  for (i = 0; i < 3; i++) {
    /* Gain: '<S9>/M' */
    ctrl_custom_B.M[i] = 0.0;

    /* Product: '<S9>/Matrix Multiply2' */
    ctrl_custom_B.MatrixMultiply2[i] = 0.0;

    /* MATLAB Function: '<S9>/BODY -> NED' */
    tmp_2[2 + 3 * i] = b[i];

    /* Gain: '<S9>/M' */
    ctrl_custom_B.M[i] += ctrl_custom_P.M_Gain[i] * tmp[0];

    /* Product: '<S9>/Matrix Multiply2' */
    ctrl_custom_B.MatrixMultiply2[i] += ctrl_custom_B.Gain1[i] * rtb_Multiply1[0];

    /* Gain: '<S9>/M' */
    ctrl_custom_B.M[i] += ctrl_custom_P.M_Gain[i + 3] * tmp[1];

    /* Product: '<S9>/Matrix Multiply2' */
    ctrl_custom_B.MatrixMultiply2[i] += ctrl_custom_B.Gain1[i + 3] *
      rtb_Multiply1[1];

    /* Gain: '<S9>/M' */
    ctrl_custom_B.M[i] += ctrl_custom_P.M_Gain[i + 6] * tmp[2];

    /* Product: '<S9>/Matrix Multiply2' */
    ctrl_custom_B.MatrixMultiply2[i] += ctrl_custom_B.Gain1[i + 6] *
      rtb_Multiply1[2];

    /* Product: '<S9>/Matrix Multiply3' incorporates:
     *  Sum: '<S9>/Sum'
     */
    tmp_0[i] = ctrl_custom_B.Gain[i + 6] * rtb_Multiply1[2] +
      (ctrl_custom_B.Gain[i + 3] * rtb_Multiply1[1] + ctrl_custom_B.Gain[i] *
       rtb_Multiply1[0]);
  }

  for (i = 0; i < 3; i++) {
    /* Sum: '<S9>/Sum' incorporates:
     *  MATLAB Function: '<S9>/BODY -> NED'
     */
    ctrl_custom_B.Sum[i] = tmp_0[i] + (tmp_2[i + 6] * ctrl_custom_B.Integrator1
      [2] + (tmp_2[i + 3] * ctrl_custom_B.Integrator1[1] + tmp_2[i] *
             ctrl_custom_B.Integrator1[0]));

    /* Sum: '<S12>/Sum2' incorporates:
     *  Constant: '<Root>/Constant'
     *  Gain: '<S12>/Gain'
     *  Integrator: '<S12>/Integrator'
     */
    tmp[i] = ctrl_custom_P.Constant_Value_d[i] -
      ctrl_custom_X.Integrator_CSTATE_n[i];
  }

  for (i = 0; i < 3; i++) {
    /* Gain: '<S12>/Gain' */
    ctrl_custom_B.Gain_d[i] = 0.0;
    ctrl_custom_B.Gain_d[i] += ctrl_custom_P.Omega[i] * tmp[0];
    ctrl_custom_B.Gain_d[i] += ctrl_custom_P.Omega[i + 3] * tmp[1];
    ctrl_custom_B.Gain_d[i] += ctrl_custom_P.Omega[i + 6] * tmp[2];

    /* Gain: '<S12>/Gain1' incorporates:
     *  Integrator: '<S12>/Integrator'
     */
    rtb_Multiply1[i] = ctrl_custom_P.Gain1_Gain_k[i + 6] *
      ctrl_custom_X.Integrator_CSTATE_n[2] + (ctrl_custom_P.Gain1_Gain_k[i + 3] *
      ctrl_custom_X.Integrator_CSTATE_n[1] + ctrl_custom_P.Gain1_Gain_k[i] *
      ctrl_custom_X.Integrator_CSTATE_n[0]);

    /* Gain: '<S12>/Gain15' incorporates:
     *  Sum: '<S12>/Sum'
     */
    tmp_0[i] = ctrl_custom_P.Gain15_Gain[i + 6] * ctrl_custom_B.Integrator2[2] +
      (ctrl_custom_P.Gain15_Gain[i + 3] * ctrl_custom_B.Integrator2[1] +
       ctrl_custom_P.Gain15_Gain[i] * ctrl_custom_B.Integrator2[0]);
  }

  /* Saturate: '<S12>/Saturation' */
  if (rtb_Multiply1[0] > ctrl_custom_P.Saturation_UpperSat) {
    /* Sum: '<S12>/Sum' */
    tmp_3[0] = ctrl_custom_P.Saturation_UpperSat;
  } else if (rtb_Multiply1[0] < ctrl_custom_P.Saturation_LowerSat) {
    /* Sum: '<S12>/Sum' */
    tmp_3[0] = ctrl_custom_P.Saturation_LowerSat;
  } else {
    /* Sum: '<S12>/Sum' */
    tmp_3[0] = rtb_Multiply1[0];
  }

  /* End of Saturate: '<S12>/Saturation' */

  /* Saturate: '<S12>/Saturation2' */
  if (rtb_Multiply1[1] > ctrl_custom_P.Saturation2_UpperSat) {
    /* Sum: '<S12>/Sum' */
    tmp_3[1] = ctrl_custom_P.Saturation2_UpperSat;
  } else if (rtb_Multiply1[1] < ctrl_custom_P.Saturation2_LowerSat) {
    /* Sum: '<S12>/Sum' */
    tmp_3[1] = ctrl_custom_P.Saturation2_LowerSat;
  } else {
    /* Sum: '<S12>/Sum' */
    tmp_3[1] = rtb_Multiply1[1];
  }

  /* End of Saturate: '<S12>/Saturation2' */

  /* Saturate: '<S12>/Saturation3' */
  if (rtb_Multiply1[2] > ctrl_custom_P.Saturation3_UpperSat) {
    /* Sum: '<S12>/Sum' */
    tmp_3[2] = ctrl_custom_P.Saturation3_UpperSat;
  } else if (rtb_Multiply1[2] < ctrl_custom_P.Saturation3_LowerSat) {
    /* Sum: '<S12>/Sum' */
    tmp_3[2] = ctrl_custom_P.Saturation3_LowerSat;
  } else {
    /* Sum: '<S12>/Sum' */
    tmp_3[2] = rtb_Multiply1[2];
  }

  /* End of Saturate: '<S12>/Saturation3' */

  /* Sum: '<S12>/Sum1' incorporates:
   *  Gain: '<S12>/Gain14'
   *  Sum: '<S12>/Sum'
   */
  for (i = 0; i < 3; i++) {
    ctrl_custom_B.Sum1[i] = (tmp_3[i] - tmp_0[i]) -
      ((ctrl_custom_P.Gain14_Gain[i + 3] *
        ctrl_custom_B.TmpSignalConversionAtGain14Inpo[1] +
        ctrl_custom_P.Gain14_Gain[i] *
        ctrl_custom_B.TmpSignalConversionAtGain14Inpo[0]) +
       ctrl_custom_P.Gain14_Gain[i + 6] *
       ctrl_custom_B.TmpSignalConversionAtGain14Inpo[2]);
  }

  /* End of Sum: '<S12>/Sum1' */
  if (rtmIsMajorTimeStep(ctrl_custom_M)) {
    /* MATLAB Function: '<S3>/Switch_function' incorporates:
     *  Memory: '<S3>/Memory'
     */
    /* MATLAB Function 'Hold block/Switch_function': '<S31>:1' */
    /*  Function that takes in impulse button sigals [0,1] and sends out a  */
    /*  different signal depentent pn which button has been pressed */
    /* '<S31>:1:8' */
    rtb_Memory = ctrl_custom_DW.Memory_PreviousInput_m;
    if (ctrl_custom_B.DPmanual != 0.0) {
      /* '<S31>:1:10' */
      if (ctrl_custom_DW.Memory_PreviousInput_m == 0.0) {
        /* '<S31>:1:11' */
        /* '<S31>:1:12' */
        rtb_Memory = 1.0;
      } else {
        /* '<S31>:1:14' */
        rtb_Memory = 0.0;
      }
    }

    /* '<S31>:1:18' */
    ctrl_custom_B.switch_signal = rtb_Memory;

    /* End of MATLAB Function: '<S3>/Switch_function' */

    /* Sum: '<S3>/Sum' incorporates:
     *  Constant: '<S3>/Constant'
     */
    ctrl_custom_B.Sum_b = ctrl_custom_B.switch_signal +
      ctrl_custom_P.Constant_Value_g;
  }

  /* MATLAB Function: '<Root>/MATLAB Function1' incorporates:
   *  SignalConversion: '<S5>/TmpSignal ConversionAt SFunction Inport1'
   */
  /* MATLAB Function 'MATLAB Function1': '<S5>:1' */
  if (!ctrl_custom_DW.init_flag_not_empty) {
    /* '<S5>:1:3' */
    ctrl_custom_DW.init_flag_not_empty = true;

    /* '<S5>:1:5' */
    ctrl_custom_DW.eta_mem[0] = ctrl_custom_B.x_m;
    ctrl_custom_DW.eta_mem[1] = ctrl_custom_B.y_m;
    ctrl_custom_DW.eta_mem[2] = ctrl_custom_B.psi_m;
  }

  /* End of MATLAB Function: '<Root>/MATLAB Function1' */

  /* MATLAB Function: '<Root>/MATLAB Function2' incorporates:
   *  SignalConversion: '<S6>/TmpSignal ConversionAt SFunction Inport1'
   */
  /* '<S5>:1:7' */
  /* MATLAB Function 'MATLAB Function2': '<S6>:1' */
  if (((ctrl_custom_DW.eta_frozen[0] + ctrl_custom_DW.eta_frozen[1]) +
       ctrl_custom_DW.eta_frozen[2] == 0.0) && (ctrl_custom_B.Freeze == 1.0)) {
    /* '<S6>:1:6' */
    /* '<S6>:1:7' */
    /* '<S6>:1:8' */
    ctrl_custom_DW.eta_frozen[0] = ctrl_custom_B.x_m;
    ctrl_custom_B.eta_out_n[0] = ctrl_custom_DW.eta_frozen[0];
    ctrl_custom_DW.eta_frozen[1] = ctrl_custom_B.y_m;
    ctrl_custom_B.eta_out_n[1] = ctrl_custom_DW.eta_frozen[1];
    ctrl_custom_DW.eta_frozen[2] = ctrl_custom_B.psi_m;
    ctrl_custom_B.eta_out_n[2] = ctrl_custom_DW.eta_frozen[2];
  } else if (ctrl_custom_B.Freeze == 1.0) {
    /* '<S6>:1:9' */
    /* '<S6>:1:10' */
    ctrl_custom_B.eta_out_n[0] = ctrl_custom_DW.eta_frozen[0];
    ctrl_custom_B.eta_out_n[1] = ctrl_custom_DW.eta_frozen[1];
    ctrl_custom_B.eta_out_n[2] = ctrl_custom_DW.eta_frozen[2];
  } else {
    /* '<S6>:1:12' */
    /* '<S6>:1:13' */
    ctrl_custom_DW.eta_frozen[0] = 0.0;
    ctrl_custom_B.eta_out_n[0] = ctrl_custom_B.x_m;
    ctrl_custom_DW.eta_frozen[1] = 0.0;
    ctrl_custom_B.eta_out_n[1] = ctrl_custom_B.y_m;
    ctrl_custom_DW.eta_frozen[2] = 0.0;
    ctrl_custom_B.eta_out_n[2] = ctrl_custom_B.psi_m;
  }

  /* End of MATLAB Function: '<Root>/MATLAB Function2' */
  /* '<S6>:1:15' */
  if (rtmIsMajorTimeStep(ctrl_custom_M)) {
    /* MultiPortSwitch: '<Root>/Multiport Switch1' incorporates:
     *  Gain: '<S13>/Gain3'
     *  MATLAB Function: '<S2>/surge force'
     *  MATLAB Function: '<S2>/sway force'
     *  MATLAB Function: '<S2>/yaw negative conversion'
     *  MATLAB Function: '<S2>/yaw positive conversion'
     *  Sum: '<S2>/Sum'
     */
    /* MATLAB Function 'Conversion/surge force': '<S27>:1' */
    /* '<S27>:1:2' */
    /* '<S27>:1:3' */
    /* MATLAB Function 'Conversion/sway force': '<S28>:1' */
    /* '<S28>:1:2' */
    /* '<S28>:1:3' */
    /* MATLAB Function 'Conversion/yaw negative conversion': '<S29>:1' */
    /* '<S29>:1:2' */
    /* '<S29>:1:3' */
    /* MATLAB Function 'Conversion/yaw positive conversion': '<S30>:1' */
    /* '<S30>:1:2' */
    /* '<S30>:1:3' */
    switch ((int32_T)ctrl_custom_B.Sum_b) {
     case 1:
      ctrl_custom_B.MultiportSwitch1[0] = (ctrl_custom_P.Gain3_Gain *
        ctrl_custom_B.LstickUD - -1.0) * 2.06 + -2.06;
      ctrl_custom_B.MultiportSwitch1[1] = (ctrl_custom_B.LstickRL - -1.0) *
        4.689 + -4.689;
      ctrl_custom_B.MultiportSwitch1[2] = (ctrl_custom_B.L2 - -1.0) * -0.98075 +
        (ctrl_custom_B.R2 - -1.0) * 0.98075;
      break;

     case 2:
      ctrl_custom_B.MultiportSwitch1[0] = 0.0;
      ctrl_custom_B.MultiportSwitch1[1] = 0.0;
      ctrl_custom_B.MultiportSwitch1[2] = 0.0;
      break;

     default:
      ctrl_custom_B.MultiportSwitch1[0] = 0.0;
      ctrl_custom_B.MultiportSwitch1[1] = 0.0;
      ctrl_custom_B.MultiportSwitch1[2] = 0.0;
      break;
    }

    /* End of MultiPortSwitch: '<Root>/Multiport Switch1' */
  }
}

/* Model update function */
void ctrl_custom_update(void)
{
  real_T (*lastU)[3];

  /* Update for Derivative: '<Root>/Derivative1' */
  if (ctrl_custom_DW.TimeStampA == (rtInf)) {
    ctrl_custom_DW.TimeStampA = ctrl_custom_M->Timing.t[0];
    lastU = (real_T (*)[3])ctrl_custom_DW.LastUAtTimeA;
  } else if (ctrl_custom_DW.TimeStampB == (rtInf)) {
    ctrl_custom_DW.TimeStampB = ctrl_custom_M->Timing.t[0];
    lastU = (real_T (*)[3])ctrl_custom_DW.LastUAtTimeB;
  } else if (ctrl_custom_DW.TimeStampA < ctrl_custom_DW.TimeStampB) {
    ctrl_custom_DW.TimeStampA = ctrl_custom_M->Timing.t[0];
    lastU = (real_T (*)[3])ctrl_custom_DW.LastUAtTimeA;
  } else {
    ctrl_custom_DW.TimeStampB = ctrl_custom_M->Timing.t[0];
    lastU = (real_T (*)[3])ctrl_custom_DW.LastUAtTimeB;
  }

  (*lastU)[0] = ctrl_custom_B.x_m;
  (*lastU)[1] = ctrl_custom_B.y_m;
  (*lastU)[2] = ctrl_custom_B.psi_m;

  /* End of Update for Derivative: '<Root>/Derivative1' */
  if (rtmIsMajorTimeStep(ctrl_custom_M)) {
    /* Update for Memory: '<S7>/Memory' */
    ctrl_custom_DW.Memory_PreviousInput = ctrl_custom_B.eta_out[0];

    /* Update for Memory: '<S7>/Memory1' */
    ctrl_custom_DW.Memory1_PreviousInput = ctrl_custom_B.eta_out[1];

    /* Update for Memory: '<S7>/Memory2' */
    ctrl_custom_DW.Memory2_PreviousInput = ctrl_custom_B.eta_out[2];

    /* Update for UnitDelay: '<Root>/Unit Delay1' */
    ctrl_custom_DW.UnitDelay1_DSTATE[0] = ctrl_custom_B.eta_out_n[0];
    ctrl_custom_DW.UnitDelay1_DSTATE[1] = ctrl_custom_B.eta_out_n[1];
    ctrl_custom_DW.UnitDelay1_DSTATE[2] = ctrl_custom_B.eta_out_n[2];

    /* Update for Memory: '<S3>/Memory' */
    ctrl_custom_DW.Memory_PreviousInput_m = ctrl_custom_B.switch_signal;
  }

  if (rtmIsMajorTimeStep(ctrl_custom_M)) {
    rt_ertODEUpdateContinuousStates(&ctrl_custom_M->solverInfo);
  }

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   * Timer of this task consists of two 32 bit unsigned integers.
   * The two integers represent the low bits Timing.clockTick0 and the high bits
   * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
   */
  if (!(++ctrl_custom_M->Timing.clockTick0)) {
    ++ctrl_custom_M->Timing.clockTickH0;
  }

  ctrl_custom_M->Timing.t[0] = rtsiGetSolverStopTime(&ctrl_custom_M->solverInfo);

  {
    /* Update absolute timer for sample time: [0.01s, 0.0s] */
    /* The "clockTick1" counts the number of times the code of this task has
     * been executed. The absolute time is the multiplication of "clockTick1"
     * and "Timing.stepSize1". Size of "clockTick1" ensures timer will not
     * overflow during the application lifespan selected.
     * Timer of this task consists of two 32 bit unsigned integers.
     * The two integers represent the low bits Timing.clockTick1 and the high bits
     * Timing.clockTickH1. When the low bit overflows to 0, the high bits increment.
     */
    if (!(++ctrl_custom_M->Timing.clockTick1)) {
      ++ctrl_custom_M->Timing.clockTickH1;
    }

    ctrl_custom_M->Timing.t[1] = ctrl_custom_M->Timing.clockTick1 *
      ctrl_custom_M->Timing.stepSize1 + ctrl_custom_M->Timing.clockTickH1 *
      ctrl_custom_M->Timing.stepSize1 * 4294967296.0;
  }
}

/* Derivatives for root system: '<Root>' */
void ctrl_custom_derivatives(void)
{
  XDot_ctrl_custom_T *_rtXdot;
  _rtXdot = ((XDot_ctrl_custom_T *) ctrl_custom_M->derivs);

  /* Derivatives for Integrator: '<S9>/Integrator' */
  _rtXdot->Integrator_CSTATE[0] = ctrl_custom_B.Sum[0];

  /* Derivatives for Integrator: '<S12>/Integrator2' */
  _rtXdot->Integrator2_CSTATE[0] =
    ctrl_custom_B.TmpSignalConversionAtGain14Inpo[0];

  /* Derivatives for Integrator: '<S9>/Integrator2' */
  _rtXdot->Integrator2_CSTATE_k[0] = ctrl_custom_B.MatrixMultiply2[0];

  /* Derivatives for Integrator: '<S12>/Integrator1' */
  _rtXdot->Integrator1_CSTATE[0] = ctrl_custom_B.Sum1[0];

  /* Derivatives for Integrator: '<S9>/Integrator1' */
  _rtXdot->Integrator1_CSTATE_c[0] = ctrl_custom_B.M[0];

  /* Derivatives for Integrator: '<S1>/Integrator1' */
  _rtXdot->Integrator1_CSTATE_b[0] =
    ctrl_custom_B.TmpSignalConversionAtMultiply1I[0];

  /* Derivatives for Integrator: '<S12>/Integrator' */
  _rtXdot->Integrator_CSTATE_n[0] = ctrl_custom_B.Gain_d[0];

  /* Derivatives for Integrator: '<S9>/Integrator' */
  _rtXdot->Integrator_CSTATE[1] = ctrl_custom_B.Sum[1];

  /* Derivatives for Integrator: '<S12>/Integrator2' */
  _rtXdot->Integrator2_CSTATE[1] =
    ctrl_custom_B.TmpSignalConversionAtGain14Inpo[1];

  /* Derivatives for Integrator: '<S9>/Integrator2' */
  _rtXdot->Integrator2_CSTATE_k[1] = ctrl_custom_B.MatrixMultiply2[1];

  /* Derivatives for Integrator: '<S12>/Integrator1' */
  _rtXdot->Integrator1_CSTATE[1] = ctrl_custom_B.Sum1[1];

  /* Derivatives for Integrator: '<S9>/Integrator1' */
  _rtXdot->Integrator1_CSTATE_c[1] = ctrl_custom_B.M[1];

  /* Derivatives for Integrator: '<S1>/Integrator1' */
  _rtXdot->Integrator1_CSTATE_b[1] =
    ctrl_custom_B.TmpSignalConversionAtMultiply1I[1];

  /* Derivatives for Integrator: '<S12>/Integrator' */
  _rtXdot->Integrator_CSTATE_n[1] = ctrl_custom_B.Gain_d[1];

  /* Derivatives for Integrator: '<S9>/Integrator' */
  _rtXdot->Integrator_CSTATE[2] = ctrl_custom_B.Sum[2];

  /* Derivatives for Integrator: '<S12>/Integrator2' */
  _rtXdot->Integrator2_CSTATE[2] =
    ctrl_custom_B.TmpSignalConversionAtGain14Inpo[2];

  /* Derivatives for Integrator: '<S9>/Integrator2' */
  _rtXdot->Integrator2_CSTATE_k[2] = ctrl_custom_B.MatrixMultiply2[2];

  /* Derivatives for Integrator: '<S12>/Integrator1' */
  _rtXdot->Integrator1_CSTATE[2] = ctrl_custom_B.Sum1[2];

  /* Derivatives for Integrator: '<S9>/Integrator1' */
  _rtXdot->Integrator1_CSTATE_c[2] = ctrl_custom_B.M[2];

  /* Derivatives for Integrator: '<S1>/Integrator1' */
  _rtXdot->Integrator1_CSTATE_b[2] =
    ctrl_custom_B.TmpSignalConversionAtMultiply1I[2];

  /* Derivatives for Integrator: '<S12>/Integrator' */
  _rtXdot->Integrator_CSTATE_n[2] = ctrl_custom_B.Gain_d[2];
}

/* Model initialize function */
void ctrl_custom_initialize(void)
{
  /* InitializeConditions for Derivative: '<Root>/Derivative1' */
  ctrl_custom_DW.TimeStampA = (rtInf);
  ctrl_custom_DW.TimeStampB = (rtInf);

  /* InitializeConditions for Memory: '<S7>/Memory' */
  ctrl_custom_DW.Memory_PreviousInput = ctrl_custom_P.Memory_X0;

  /* InitializeConditions for Memory: '<S7>/Memory1' */
  ctrl_custom_DW.Memory1_PreviousInput = ctrl_custom_P.Memory1_X0;

  /* InitializeConditions for Memory: '<S7>/Memory2' */
  ctrl_custom_DW.Memory2_PreviousInput = ctrl_custom_P.Memory2_X0;

  /* InitializeConditions for Memory: '<S3>/Memory' */
  ctrl_custom_DW.Memory_PreviousInput_m = ctrl_custom_P.Memory_X0_o;

  /* SystemInitialize for MATLAB Function: '<Root>/loss of signal 1' */
  ctrl_custom_DW.counter = 0.0;

  /* SystemInitialize for MATLAB Function: '<Root>/MATLAB Function1' */
  ctrl_custom_DW.init_flag_not_empty = false;

  /* InitializeConditions for Integrator: '<S9>/Integrator' */
  ctrl_custom_X.Integrator_CSTATE[0] = ctrl_custom_P.Integrator_IC;

  /* InitializeConditions for Integrator: '<S12>/Integrator2' */
  ctrl_custom_X.Integrator2_CSTATE[0] = ctrl_custom_P.Integrator2_IC;

  /* InitializeConditions for Integrator: '<S9>/Integrator2' */
  ctrl_custom_X.Integrator2_CSTATE_k[0] = ctrl_custom_P.Integrator2_IC_b;

  /* InitializeConditions for Integrator: '<S12>/Integrator1' */
  ctrl_custom_X.Integrator1_CSTATE[0] = ctrl_custom_P.Integrator1_IC;

  /* InitializeConditions for Integrator: '<S9>/Integrator1' */
  ctrl_custom_X.Integrator1_CSTATE_c[0] = ctrl_custom_P.Integrator1_IC_n;

  /* InitializeConditions for Integrator: '<S1>/Integrator1' */
  ctrl_custom_X.Integrator1_CSTATE_b[0] = ctrl_custom_P.Integrator1_IC_c;

  /* InitializeConditions for UnitDelay: '<Root>/Unit Delay1' */
  ctrl_custom_DW.UnitDelay1_DSTATE[0] =
    ctrl_custom_P.UnitDelay1_InitialCondition;

  /* InitializeConditions for Integrator: '<S12>/Integrator' */
  ctrl_custom_X.Integrator_CSTATE_n[0] = ctrl_custom_P.Integrator_IC_h;

  /* SystemInitialize for MATLAB Function: '<Root>/MATLAB Function2' */
  ctrl_custom_DW.eta_frozen[0] = 0.0;

  /* InitializeConditions for Integrator: '<S9>/Integrator' */
  ctrl_custom_X.Integrator_CSTATE[1] = ctrl_custom_P.Integrator_IC;

  /* InitializeConditions for Integrator: '<S12>/Integrator2' */
  ctrl_custom_X.Integrator2_CSTATE[1] = ctrl_custom_P.Integrator2_IC;

  /* InitializeConditions for Integrator: '<S9>/Integrator2' */
  ctrl_custom_X.Integrator2_CSTATE_k[1] = ctrl_custom_P.Integrator2_IC_b;

  /* InitializeConditions for Integrator: '<S12>/Integrator1' */
  ctrl_custom_X.Integrator1_CSTATE[1] = ctrl_custom_P.Integrator1_IC;

  /* InitializeConditions for Integrator: '<S9>/Integrator1' */
  ctrl_custom_X.Integrator1_CSTATE_c[1] = ctrl_custom_P.Integrator1_IC_n;

  /* InitializeConditions for Integrator: '<S1>/Integrator1' */
  ctrl_custom_X.Integrator1_CSTATE_b[1] = ctrl_custom_P.Integrator1_IC_c;

  /* InitializeConditions for UnitDelay: '<Root>/Unit Delay1' */
  ctrl_custom_DW.UnitDelay1_DSTATE[1] =
    ctrl_custom_P.UnitDelay1_InitialCondition;

  /* InitializeConditions for Integrator: '<S12>/Integrator' */
  ctrl_custom_X.Integrator_CSTATE_n[1] = ctrl_custom_P.Integrator_IC_h;

  /* SystemInitialize for MATLAB Function: '<Root>/MATLAB Function2' */
  ctrl_custom_DW.eta_frozen[1] = 0.0;

  /* InitializeConditions for Integrator: '<S9>/Integrator' */
  ctrl_custom_X.Integrator_CSTATE[2] = ctrl_custom_P.Integrator_IC;

  /* InitializeConditions for Integrator: '<S12>/Integrator2' */
  ctrl_custom_X.Integrator2_CSTATE[2] = ctrl_custom_P.Integrator2_IC;

  /* InitializeConditions for Integrator: '<S9>/Integrator2' */
  ctrl_custom_X.Integrator2_CSTATE_k[2] = ctrl_custom_P.Integrator2_IC_b;

  /* InitializeConditions for Integrator: '<S12>/Integrator1' */
  ctrl_custom_X.Integrator1_CSTATE[2] = ctrl_custom_P.Integrator1_IC;

  /* InitializeConditions for Integrator: '<S9>/Integrator1' */
  ctrl_custom_X.Integrator1_CSTATE_c[2] = ctrl_custom_P.Integrator1_IC_n;

  /* InitializeConditions for Integrator: '<S1>/Integrator1' */
  ctrl_custom_X.Integrator1_CSTATE_b[2] = ctrl_custom_P.Integrator1_IC_c;

  /* InitializeConditions for UnitDelay: '<Root>/Unit Delay1' */
  ctrl_custom_DW.UnitDelay1_DSTATE[2] =
    ctrl_custom_P.UnitDelay1_InitialCondition;

  /* InitializeConditions for Integrator: '<S12>/Integrator' */
  ctrl_custom_X.Integrator_CSTATE_n[2] = ctrl_custom_P.Integrator_IC_h;

  /* SystemInitialize for MATLAB Function: '<Root>/MATLAB Function2' */
  ctrl_custom_DW.eta_frozen[2] = 0.0;
}

/* Model terminate function */
void ctrl_custom_terminate(void)
{
  /* (no terminate code required) */
}

/*========================================================================*
 * Start of Classic call interface                                        *
 *========================================================================*/

/* Solver interface called by GRT_Main */
#ifndef USE_GENERATED_SOLVER

void rt_ODECreateIntegrationData(RTWSolverInfo *si)
{
  UNUSED_PARAMETER(si);
  return;
}                                      /* do nothing */

void rt_ODEDestroyIntegrationData(RTWSolverInfo *si)
{
  UNUSED_PARAMETER(si);
  return;
}                                      /* do nothing */

void rt_ODEUpdateContinuousStates(RTWSolverInfo *si)
{
  UNUSED_PARAMETER(si);
  return;
}                                      /* do nothing */

#endif

void MdlOutputs(int_T tid)
{
  ctrl_custom_output();
  UNUSED_PARAMETER(tid);
}

void MdlUpdate(int_T tid)
{
  ctrl_custom_update();
  UNUSED_PARAMETER(tid);
}

void MdlInitializeSizes(void)
{
}

void MdlInitializeSampleTimes(void)
{
}

void MdlInitialize(void)
{
}

void MdlStart(void)
{
  ctrl_custom_initialize();
}

void MdlTerminate(void)
{
  ctrl_custom_terminate();
}

/* Registration function */
RT_MODEL_ctrl_custom_T *ctrl_custom(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)ctrl_custom_M, 0,
                sizeof(RT_MODEL_ctrl_custom_T));

  {
    /* Setup solver object */
    rtsiSetSimTimeStepPtr(&ctrl_custom_M->solverInfo,
                          &ctrl_custom_M->Timing.simTimeStep);
    rtsiSetTPtr(&ctrl_custom_M->solverInfo, &rtmGetTPtr(ctrl_custom_M));
    rtsiSetStepSizePtr(&ctrl_custom_M->solverInfo,
                       &ctrl_custom_M->Timing.stepSize0);
    rtsiSetdXPtr(&ctrl_custom_M->solverInfo, &ctrl_custom_M->derivs);
    rtsiSetContStatesPtr(&ctrl_custom_M->solverInfo, (real_T **)
                         &ctrl_custom_M->contStates);
    rtsiSetNumContStatesPtr(&ctrl_custom_M->solverInfo,
      &ctrl_custom_M->Sizes.numContStates);
    rtsiSetNumPeriodicContStatesPtr(&ctrl_custom_M->solverInfo,
      &ctrl_custom_M->Sizes.numPeriodicContStates);
    rtsiSetPeriodicContStateIndicesPtr(&ctrl_custom_M->solverInfo,
      &ctrl_custom_M->periodicContStateIndices);
    rtsiSetPeriodicContStateRangesPtr(&ctrl_custom_M->solverInfo,
      &ctrl_custom_M->periodicContStateRanges);
    rtsiSetErrorStatusPtr(&ctrl_custom_M->solverInfo, (&rtmGetErrorStatus
      (ctrl_custom_M)));
    rtsiSetRTModelPtr(&ctrl_custom_M->solverInfo, ctrl_custom_M);
  }

  rtsiSetSimTimeStep(&ctrl_custom_M->solverInfo, MAJOR_TIME_STEP);
  ctrl_custom_M->intgData.y = ctrl_custom_M->odeY;
  ctrl_custom_M->intgData.f[0] = ctrl_custom_M->odeF[0];
  ctrl_custom_M->intgData.f[1] = ctrl_custom_M->odeF[1];
  ctrl_custom_M->intgData.f[2] = ctrl_custom_M->odeF[2];
  ctrl_custom_M->intgData.f[3] = ctrl_custom_M->odeF[3];
  ctrl_custom_M->contStates = ((real_T *) &ctrl_custom_X);
  rtsiSetSolverData(&ctrl_custom_M->solverInfo, (void *)&ctrl_custom_M->intgData);
  rtsiSetSolverName(&ctrl_custom_M->solverInfo,"ode4");

  /* Initialize timing info */
  {
    int_T *mdlTsMap = ctrl_custom_M->Timing.sampleTimeTaskIDArray;
    mdlTsMap[0] = 0;
    mdlTsMap[1] = 1;
    ctrl_custom_M->Timing.sampleTimeTaskIDPtr = (&mdlTsMap[0]);
    ctrl_custom_M->Timing.sampleTimes = (&ctrl_custom_M->
      Timing.sampleTimesArray[0]);
    ctrl_custom_M->Timing.offsetTimes = (&ctrl_custom_M->
      Timing.offsetTimesArray[0]);

    /* task periods */
    ctrl_custom_M->Timing.sampleTimes[0] = (0.0);
    ctrl_custom_M->Timing.sampleTimes[1] = (0.01);

    /* task offsets */
    ctrl_custom_M->Timing.offsetTimes[0] = (0.0);
    ctrl_custom_M->Timing.offsetTimes[1] = (0.0);
  }

  rtmSetTPtr(ctrl_custom_M, &ctrl_custom_M->Timing.tArray[0]);

  {
    int_T *mdlSampleHits = ctrl_custom_M->Timing.sampleHitArray;
    mdlSampleHits[0] = 1;
    mdlSampleHits[1] = 1;
    ctrl_custom_M->Timing.sampleHits = (&mdlSampleHits[0]);
  }

  rtmSetTFinal(ctrl_custom_M, 100.0);
  ctrl_custom_M->Timing.stepSize0 = 0.01;
  ctrl_custom_M->Timing.stepSize1 = 0.01;

  /* Setup for data logging */
  {
    static RTWLogInfo rt_DataLoggingInfo;
    rt_DataLoggingInfo.loggingInterval = NULL;
    ctrl_custom_M->rtwLogInfo = &rt_DataLoggingInfo;
  }

  /* Setup for data logging */
  {
    rtliSetLogXSignalInfo(ctrl_custom_M->rtwLogInfo, (NULL));
    rtliSetLogXSignalPtrs(ctrl_custom_M->rtwLogInfo, (NULL));
    rtliSetLogT(ctrl_custom_M->rtwLogInfo, "tout");
    rtliSetLogX(ctrl_custom_M->rtwLogInfo, "");
    rtliSetLogXFinal(ctrl_custom_M->rtwLogInfo, "");
    rtliSetLogVarNameModifier(ctrl_custom_M->rtwLogInfo, "rt_");
    rtliSetLogFormat(ctrl_custom_M->rtwLogInfo, 0);
    rtliSetLogMaxRows(ctrl_custom_M->rtwLogInfo, 1000);
    rtliSetLogDecimation(ctrl_custom_M->rtwLogInfo, 1);
    rtliSetLogY(ctrl_custom_M->rtwLogInfo, "");
    rtliSetLogYSignalInfo(ctrl_custom_M->rtwLogInfo, (NULL));
    rtliSetLogYSignalPtrs(ctrl_custom_M->rtwLogInfo, (NULL));
  }

  ctrl_custom_M->solverInfoPtr = (&ctrl_custom_M->solverInfo);
  ctrl_custom_M->Timing.stepSize = (0.01);
  rtsiSetFixedStepSize(&ctrl_custom_M->solverInfo, 0.01);
  rtsiSetSolverMode(&ctrl_custom_M->solverInfo, SOLVER_MODE_SINGLETASKING);

  /* block I/O */
  ctrl_custom_M->blockIO = ((void *) &ctrl_custom_B);
  (void) memset(((void *) &ctrl_custom_B), 0,
                sizeof(B_ctrl_custom_T));

  /* parameters */
  ctrl_custom_M->defaultParam = ((real_T *)&ctrl_custom_P);

  /* states (continuous) */
  {
    real_T *x = (real_T *) &ctrl_custom_X;
    ctrl_custom_M->contStates = (x);
    (void) memset((void *)&ctrl_custom_X, 0,
                  sizeof(X_ctrl_custom_T));
  }

  /* states (dwork) */
  ctrl_custom_M->dwork = ((void *) &ctrl_custom_DW);
  (void) memset((void *)&ctrl_custom_DW, 0,
                sizeof(DW_ctrl_custom_T));

  /* Initialize Sizes */
  ctrl_custom_M->Sizes.numContStates = (21);/* Number of continuous states */
  ctrl_custom_M->Sizes.numPeriodicContStates = (0);/* Number of periodic continuous states */
  ctrl_custom_M->Sizes.numY = (0);     /* Number of model outputs */
  ctrl_custom_M->Sizes.numU = (0);     /* Number of model inputs */
  ctrl_custom_M->Sizes.sysDirFeedThru = (0);/* The model is not direct feedthrough */
  ctrl_custom_M->Sizes.numSampTimes = (2);/* Number of sample times */
  ctrl_custom_M->Sizes.numBlocks = (142);/* Number of blocks */
  ctrl_custom_M->Sizes.numBlockIO = (41);/* Number of block outputs */
  ctrl_custom_M->Sizes.numBlockPrms = (413);/* Sum of parameter "widths" */
  return ctrl_custom_M;
}

/*========================================================================*
 * End of Classic call interface                                          *
 *========================================================================*/

/*========================================================================*
 * NI VeriStand Model Framework code generation
 *
 * Model : ctrl_custom
 * Model version : 1.290
 * VeriStand Model Framework version : 2017.0.0.143 (2017)
 * Source generated on : Tue May 28 15:35:15 2019
 *========================================================================*/

/* This file contains automatically generated code for functions
 * to update the inports and outports of a Simulink/Realtime Workshop
 * model. Calls to these functions should be made before each step is taken
 * (inports, call SetExternalInputs) and after each step is taken
 * (outports, call SetExternalOutputs.)
 */
#ifdef NI_ROOTMODEL_ctrl_custom
#include "ni_modelframework_ex.h"
#include <stddef.h>
#include <stdlib.h>
#include <float.h>
#include <math.h>

unsigned char ReadSideDirtyFlag = 0, WriteSideDirtyFlag = 0;

/*========================================================================*
 * Function: NIRT_GetValueByDataType
 *
 * Abstract:
 *		Converting to and from double and datatypes used in the model
 *
 * Output Parameters
 *      ptr : address to the source
 *      subindex : index value if vector
 *      type   : the source's data type
 *      Complex : true if a complex data type
 *
 * Returns:
 *     Return value: 0 if no error
 *========================================================================*/
double NIRT_GetValueByDataType(void* ptr, int32_t subindex, int32_t type,
  int32_t Complex)
{
  switch (type)
  {
   case 0:
    return (double)(((real_T*)ptr)[subindex]);

   case 1:
    return (double)(((real32_T*)ptr)[subindex]);

   case 2:
    return (double)(((int8_T*)ptr)[subindex]);

   case 3:
    return (double)(((uint8_T*)ptr)[subindex]);

   case 4:
    return (double)(((int16_T*)ptr)[subindex]);

   case 5:
    return (double)(((uint16_T*)ptr)[subindex]);

   case 6:
    return (double)(((int32_T*)ptr)[subindex]);

   case 7:
    return (double)(((uint32_T*)ptr)[subindex]);

   case 8:
    return (double)(((boolean_T*)ptr)[subindex]);

   case 10:
    return NIRT_GetValueByDataType(ptr,subindex,6,Complex);

   case 13:
    return NIRT_GetValueByDataType(ptr,subindex,7,Complex);

   case 15:
    return NIRT_GetValueByDataType(ptr,subindex,6,Complex);

   case 16:
    return NIRT_GetValueByDataType(ptr,subindex,6,Complex);

   case 17:
    return NIRT_GetValueByDataType(ptr,subindex,3,Complex);

   case 18:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 19:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 20:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 21:
    return NIRT_GetValueByDataType(ptr,subindex,3,Complex);

   case 22:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 23:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 24:
    return NIRT_GetValueByDataType(ptr,subindex,11,Complex);

   case 27:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 28:
    return NIRT_GetValueByDataType(ptr,subindex,8,Complex);

   case 29:
    return (( double *)ptr)[subindex];

   case 30:
    return (( double *)ptr)[subindex];

   case 31:
    return (( double *)ptr)[subindex];

   case 32:
    return (( double *)ptr)[subindex];

   case 33:
    return (( double *)ptr)[subindex];

   case 34:
    return (( double *)ptr)[subindex];

   case 35:
    return (( double *)ptr)[subindex];

   case 36:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 37:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);
  }

  // return ((double *)ptr)[subindex];
  return rtNaN;
}

/*========================================================================*
 * Function: NIRT_SetValueByDataType
 *
 * Abstract:
 *		Converting to and from double and datatypes used in the model
 *
 * Output Parameters
 *      ptr : address to the destination
 *      subindex : index value if vector
 *      value : value to set on the destination
 *      type   : the destination's data type
 *      Complex : true if a complex data type
 *
 * Returns:
 *     Return value: 0 if no error
 *========================================================================*/
int32_t NIRT_SetValueByDataType(void* ptr, int32_t subindex, double value,
  int32_t type, int32_t Complex)
{
  //Complex is only used for R14.3 and down
  switch (type)
  {
   case 0:
    ((real_T *)ptr)[subindex] = (real_T)value;
    return NI_OK;

   case 1:
    ((real32_T *)ptr)[subindex] = (real32_T)value;
    return NI_OK;

   case 2:
    ((int8_T *)ptr)[subindex] = (int8_T)value;
    return NI_OK;

   case 3:
    ((uint8_T *)ptr)[subindex] = (uint8_T)value;
    return NI_OK;

   case 4:
    ((int16_T *)ptr)[subindex] = (int16_T)value;
    return NI_OK;

   case 5:
    ((uint16_T *)ptr)[subindex] = (uint16_T)value;
    return NI_OK;

   case 6:
    ((int32_T *)ptr)[subindex] = (int32_T)value;
    return NI_OK;

   case 7:
    ((uint32_T *)ptr)[subindex] = (uint32_T)value;
    return NI_OK;

   case 8:
    ((boolean_T *)ptr)[subindex] = (boolean_T)value;
    return NI_OK;

   case 10:
    //Type is renamed. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 6, Complex);

   case 13:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 7, Complex);

   case 15:
    //Type is enum. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 6, Complex);

   case 16:
    //Type is enum. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 6, Complex);

   case 17:
    //Type is renamed. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 3, Complex);

   case 18:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 0, Complex);

   case 19:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 0, Complex);

   case 20:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 0, Complex);

   case 21:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 3, Complex);

   case 22:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 0, Complex);

   case 23:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 0, Complex);

   case 24:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 11, Complex);

   case 27:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 0, Complex);

   case 28:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 8, Complex);

   case 29:
    //Type is struct. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 0, Complex);

   case 30:
    //Type is struct. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 0, Complex);

   case 31:
    //Type is struct. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 0, Complex);

   case 32:
    //Type is struct. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 0, Complex);

   case 33:
    //Type is struct. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 0, Complex);

   case 34:
    //Type is struct. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 0, Complex);

   case 35:
    //Type is struct. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 0, Complex);

   case 36:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 0, Complex);

   case 37:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr, subindex, value, 0, Complex);
  }

  //No matching datatype conversion
  return NI_ERROR;
}

extern ctrl_custom_rtModel *S;
extern _SITexportglobals SITexportglobals;

/*========================================================================*
 * Function: SetExternalInputs
 *
 * Abstract:
 *		Set data to model ports on the specified task
 *
 * Input Parameters
 *      data : data to set
 *      TaskSampleHit : task id
 *
 * Returns:
 *     Return value: 0 if no error
 *========================================================================*/
void SetExternalInputs(double* data, int_T* TaskSampleHit)
{
  int index = 0, count = 0;

  // ctrl_custom/Pose/x_m
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&ctrl_custom_B.x_m, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/Pose/y_m
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&ctrl_custom_B.y_m, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/Pose/psi_m
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&ctrl_custom_B.psi_m, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/Freeze
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&ctrl_custom_B.Freeze, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/DP//manual
  if (TaskSampleHit[1]) {
    NIRT_SetValueByDataType(&ctrl_custom_B.DPmanual, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/SAXXIS input/L2
  if (TaskSampleHit[1]) {
    NIRT_SetValueByDataType(&ctrl_custom_B.L2, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/SAXXIS input/LstickR//L
  if (TaskSampleHit[1]) {
    NIRT_SetValueByDataType(&ctrl_custom_B.LstickRL, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/SAXXIS input/LstickU//D
  if (TaskSampleHit[1]) {
    NIRT_SetValueByDataType(&ctrl_custom_B.LstickUD, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/SAXXIS input/R2
  if (TaskSampleHit[1]) {
    NIRT_SetValueByDataType(&ctrl_custom_B.R2, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  UNUSED_PARAMETER(count);
}                                      /* of SetExternalInputs */

int32_t NumInputPorts(void)
{
  return 9;
}

int32_t NumOutputPorts(void)
{
  return 35;
}

double ni_extout[35];

/*========================================================================*
 * Function: SetExternalOutputs
 *
 * Abstract:
 *		Set data to model ports on the specified task
 *
 * Input Parameters
 *      data : data to set
 *      TaskSampleHit : task id
 *
 * Returns:
 *     Return value: 0 if no error
 *========================================================================*/
void SetExternalOutputs(double* data, int_T* TaskSampleHit)
{
  int index = 0, count = 0;

  // ctrl_custom/beta_est/bpsi_est: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator2_m, 2,
      18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/beta_est/bx_est: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator2_m, 0,
      18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/beta_est/by_est: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator2_m, 1,
      18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/eta/QTM_SCOPEPSI: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.psi_m, 0, 0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/eta/QTM_SCOPEX: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.x_m, 0, 0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/eta/QTM_SCOPEY: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.y_m, 0, 0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/eta_d/psi_d: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator2, 2,
      18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/eta_d/x_d: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator2, 0,
      18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/eta_d/y_d: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator2, 1,
      18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/eta_est/psi_est: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator, 2,
      18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/eta_est/x_est: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator, 0,
      18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/eta_est/y_est: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator, 1,
      18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/nu/r: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.sf_NEDBODY1.y, 2,
      18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/nu/u: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.sf_NEDBODY1.y, 0,
      18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/nu/v: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.sf_NEDBODY1.y, 1,
      18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/nu_d/omega_d: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Saturation8, 0,
      0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/nu_d/u_d: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Saturation6, 0,
      0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/nu_d/v_d: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Saturation7, 0,
      0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/nu_est/r_est: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator1, 2,
      18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/nu_est/u_est: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator1, 0,
      18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/nu_est/v_est: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator1, 1,
      18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/u/alpha_VSP1: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.alpha_1, 0, 0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/u/alpha_VSP2: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.alpha_2, 0, 0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/u/u_BT: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.u_1, 0, 0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/u/u_VSP1: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Saturation11, 0,
      0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/u/u_VSP2: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Saturation1, 0,
      0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/u/omega_VSP1: Virtual Signal # 0
  if (TaskSampleHit[1]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_P.Constant_Value,
      0, 0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/u/omega_VSP2: Virtual Signal # 0
  if (TaskSampleHit[1]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_P.Constant_Value,
      0, 0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/ PID /tau_pid /tau3: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Sum6, 2, 18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/ PID /tau_pid /tau1: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Sum6, 0, 18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/ PID /tau_pid /tau2: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Sum6, 1, 18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/DP//manualOut: Virtual Signal # 0
  if (TaskSampleHit[1]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Sum_b, 0, 0, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/tau_cmd/Tau_cmd_surge: Virtual Signal # 0
  if (TaskSampleHit[1]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.MultiportSwitch1,
      0, 18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/tau_cmd/Tau_cmd_sway: Virtual Signal # 0
  if (TaskSampleHit[1]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.MultiportSwitch1,
      1, 18, 0);
  } else {
    index += 1;
  }

  // ctrl_custom/tau_cmd/Tau_cmd_yaw: Virtual Signal # 0
  if (TaskSampleHit[1]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.MultiportSwitch1,
      2, 18, 0);
  } else {
    index += 1;
  }

  if (data != NULL) {
    memcpy(&data[0], &ni_extout[0], sizeof(ni_extout));
  }

  UNUSED_PARAMETER(count);
}

/*========================================================================*
 * Function: NI_InitExternalOutputs
 *
 * Abstract:
 *		Initialize model ports
 *
 * Output Parameters
 *
 * Returns:
 *     Return value: 0 if no error
 *========================================================================*/
int32_t NI_InitExternalOutputs()
{
  int index = 0, count = 0;

  // ctrl_custom/beta_est/bpsi_est: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator2_m, 2,
    18, 0);

  // ctrl_custom/beta_est/bx_est: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator2_m, 0,
    18, 0);

  // ctrl_custom/beta_est/by_est: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator2_m, 1,
    18, 0);

  // ctrl_custom/eta/QTM_SCOPEPSI: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.psi_m, 0, 0, 0);

  // ctrl_custom/eta/QTM_SCOPEX: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.x_m, 0, 0, 0);

  // ctrl_custom/eta/QTM_SCOPEY: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.y_m, 0, 0, 0);

  // ctrl_custom/eta_d/psi_d: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator2, 2, 18,
    0);

  // ctrl_custom/eta_d/x_d: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator2, 0, 18,
    0);

  // ctrl_custom/eta_d/y_d: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator2, 1, 18,
    0);

  // ctrl_custom/eta_est/psi_est: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator, 2, 18,
    0);

  // ctrl_custom/eta_est/x_est: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator, 0, 18,
    0);

  // ctrl_custom/eta_est/y_est: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator, 1, 18,
    0);

  // ctrl_custom/nu/r: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.sf_NEDBODY1.y, 2,
    18, 0);

  // ctrl_custom/nu/u: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.sf_NEDBODY1.y, 0,
    18, 0);

  // ctrl_custom/nu/v: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.sf_NEDBODY1.y, 1,
    18, 0);

  // ctrl_custom/nu_d/omega_d: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Saturation8, 0, 0,
    0);

  // ctrl_custom/nu_d/u_d: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Saturation6, 0, 0,
    0);

  // ctrl_custom/nu_d/v_d: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Saturation7, 0, 0,
    0);

  // ctrl_custom/nu_est/r_est: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator1, 2, 18,
    0);

  // ctrl_custom/nu_est/u_est: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator1, 0, 18,
    0);

  // ctrl_custom/nu_est/v_est: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Integrator1, 1, 18,
    0);

  // ctrl_custom/u/alpha_VSP1: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.alpha_1, 0, 0, 0);

  // ctrl_custom/u/alpha_VSP2: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.alpha_2, 0, 0, 0);

  // ctrl_custom/u/u_BT: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.u_1, 0, 0, 0);

  // ctrl_custom/u/u_VSP1: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Saturation11, 0, 0,
    0);

  // ctrl_custom/u/u_VSP2: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Saturation1, 0, 0,
    0);

  // ctrl_custom/u/omega_VSP1: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_P.Constant_Value, 0,
    0, 0);

  // ctrl_custom/u/omega_VSP2: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_P.Constant_Value, 0,
    0, 0);

  // ctrl_custom/ PID /tau_pid /tau3: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Sum6, 2, 18, 0);

  // ctrl_custom/ PID /tau_pid /tau1: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Sum6, 0, 18, 0);

  // ctrl_custom/ PID /tau_pid /tau2: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Sum6, 1, 18, 0);

  // ctrl_custom/DP//manualOut: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.Sum_b, 0, 0, 0);

  // ctrl_custom/tau_cmd/Tau_cmd_surge: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.MultiportSwitch1,
    0, 18, 0);

  // ctrl_custom/tau_cmd/Tau_cmd_sway: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.MultiportSwitch1,
    1, 18, 0);

  // ctrl_custom/tau_cmd/Tau_cmd_yaw: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&ctrl_custom_B.MultiportSwitch1,
    2, 18, 0);
  UNUSED_PARAMETER(count);
  return NI_OK;
}

/* Undefine parameter macros. The undef allows us to access the real declarations.
   In the Simulink(R) generated code, the parameters are redefined to be the read-side of rtParameter.*/
#define _NI_UNDEFINE_PARAMS_DBL_BUFFER_
#include "ni_pglobals.h"

/* All elements by default (including scalars) have 2 dimensions [1,1] */
static NI_Parameter NI_ParamList[] DataSection(".NIVS.paramlist") =
{
  { 0, "ctrl_custom/ PID /Constant26/Value", offsetof(P_ctrl_custom_T, K_d[0]),
    19, 9, 2, 0, 0 },

  { 1, "ctrl_custom/ PID /Constant25/Value", offsetof(P_ctrl_custom_T, K_i[0]),
    19, 9, 2, 2, 0 },

  { 2, "ctrl_custom/ PID /Constant24/Value", offsetof(P_ctrl_custom_T, K_p[0]),
    19, 9, 2, 4, 0 },

  { 3, "ctrl_custom/Reference model1/Gain/Gain", offsetof(P_ctrl_custom_T, Omega),
    19, 9, 2, 6, 0 },

  { 4, "ctrl_custom/Observer with bias/Integrator/InitialCondition", offsetof
    (P_ctrl_custom_T, Integrator_IC), 36, 1, 2, 8, 0 },

  { 5, "ctrl_custom/Reference model1/Integrator2/InitialCondition", offsetof
    (P_ctrl_custom_T, Integrator2_IC), 36, 1, 2, 10, 0 },

  { 6, "ctrl_custom/Observer with bias/Integrator2/InitialCondition", offsetof
    (P_ctrl_custom_T, Integrator2_IC_b), 36, 1, 2, 12, 0 },

  { 7, "ctrl_custom/Reference model1/Integrator1/InitialCondition", offsetof
    (P_ctrl_custom_T, Integrator1_IC), 36, 1, 2, 14, 0 },

  { 8, "ctrl_custom/Reference model1/Saturation8/UpperLimit", offsetof
    (P_ctrl_custom_T, Saturation8_UpperSat), 36, 1, 2, 16, 0 },

  { 9, "ctrl_custom/Reference model1/Saturation8/LowerLimit", offsetof
    (P_ctrl_custom_T, Saturation8_LowerSat), 36, 1, 2, 18, 0 },

  { 10, "ctrl_custom/Reference model1/Saturation6/UpperLimit", offsetof
    (P_ctrl_custom_T, Saturation6_UpperSat), 36, 1, 2, 20, 0 },

  { 11, "ctrl_custom/Reference model1/Saturation6/LowerLimit", offsetof
    (P_ctrl_custom_T, Saturation6_LowerSat), 36, 1, 2, 22, 0 },

  { 12, "ctrl_custom/Reference model1/Saturation7/UpperLimit", offsetof
    (P_ctrl_custom_T, Saturation7_UpperSat), 36, 1, 2, 24, 0 },

  { 13, "ctrl_custom/Reference model1/Saturation7/LowerLimit", offsetof
    (P_ctrl_custom_T, Saturation7_LowerSat), 36, 1, 2, 26, 0 },

  { 14, "ctrl_custom/Observer with bias/Integrator1/InitialCondition", offsetof
    (P_ctrl_custom_T, Integrator1_IC_n), 36, 1, 2, 28, 0 },

  { 15, "ctrl_custom/ PID /Integrator1/InitialCondition", offsetof
    (P_ctrl_custom_T, Integrator1_IC_c), 36, 1, 2, 30, 0 },

  { 16, "ctrl_custom/saturation/Saturation11/UpperLimit", offsetof
    (P_ctrl_custom_T, Saturation11_UpperSat), 36, 1, 2, 32, 0 },

  { 17, "ctrl_custom/saturation/Saturation11/LowerLimit", offsetof
    (P_ctrl_custom_T, Saturation11_LowerSat), 36, 1, 2, 34, 0 },

  { 18, "ctrl_custom/saturation/Saturation1/UpperLimit", offsetof
    (P_ctrl_custom_T, Saturation1_UpperSat), 36, 1, 2, 36, 0 },

  { 19, "ctrl_custom/saturation/Saturation1/LowerLimit", offsetof
    (P_ctrl_custom_T, Saturation1_LowerSat), 36, 1, 2, 38, 0 },

  { 20, "ctrl_custom/u/Constant/Value", offsetof(P_ctrl_custom_T, Constant_Value),
    36, 1, 2, 40, 0 },

  { 21, "ctrl_custom/Constant/Value", offsetof(P_ctrl_custom_T,
    Constant_Value_d[0]), 22, 3, 2, 42, 0 },

  { 22, "ctrl_custom/Memory block1/Memory/X0", offsetof(P_ctrl_custom_T,
    Memory_X0), 36, 1, 2, 44, 0 },

  { 23, "ctrl_custom/Memory block1/Memory1/X0", offsetof(P_ctrl_custom_T,
    Memory1_X0), 36, 1, 2, 46, 0 },

  { 24, "ctrl_custom/Memory block1/Memory2/X0", offsetof(P_ctrl_custom_T,
    Memory2_X0), 36, 1, 2, 48, 0 },

  { 25, "ctrl_custom/Observer with bias/Constant1/Value", offsetof
    (P_ctrl_custom_T, Constant1_Value), 36, 1, 2, 50, 0 },

  { 26, "ctrl_custom/Observer with bias/Constant2/Value", offsetof
    (P_ctrl_custom_T, Constant2_Value), 36, 1, 2, 52, 0 },

  { 27, "ctrl_custom/Observer with bias/Constant3/Value", offsetof
    (P_ctrl_custom_T, Constant3_Value[0]), 22, 3, 2, 54, 0 },

  { 28, "ctrl_custom/Observer with bias/Constant4/Value", offsetof
    (P_ctrl_custom_T, Constant4_Value), 36, 1, 2, 56, 0 },

  { 29, "ctrl_custom/Observer with bias/Constant5/Value", offsetof
    (P_ctrl_custom_T, Constant5_Value), 36, 1, 2, 58, 0 },

  { 30, "ctrl_custom/Observer with bias/D/Gain", offsetof(P_ctrl_custom_T,
    D_Gain), 19, 9, 2, 60, 0 },

  { 31, "ctrl_custom/Observer with bias/Gain/Gain", offsetof(P_ctrl_custom_T,
    Gain_Gain), 19, 9, 2, 62, 0 },

  { 32, "ctrl_custom/Observer with bias/Gain1/Gain", offsetof(P_ctrl_custom_T,
    Gain1_Gain), 19, 9, 2, 64, 0 },

  { 33, "ctrl_custom/Observer with bias/Gain2/Gain", offsetof(P_ctrl_custom_T,
    Gain2_Gain), 19, 9, 2, 66, 0 },

  { 34, "ctrl_custom/Unit Delay1/InitialCondition", offsetof(P_ctrl_custom_T,
    UnitDelay1_InitialCondition), 36, 1, 2, 68, 0 },

  { 35, "ctrl_custom/Observer with bias/M/Gain", offsetof(P_ctrl_custom_T,
    M_Gain), 19, 9, 2, 70, 0 },

  { 36, "ctrl_custom/Reference model1/Integrator/InitialCondition", offsetof
    (P_ctrl_custom_T, Integrator_IC_h), 36, 1, 2, 72, 0 },

  { 37, "ctrl_custom/Reference model1/Gain1/Gain", offsetof(P_ctrl_custom_T,
    Gain1_Gain_k), 19, 9, 2, 74, 0 },

  { 38, "ctrl_custom/Reference model1/Gain14/Gain", offsetof(P_ctrl_custom_T,
    Gain14_Gain), 19, 9, 2, 76, 0 },

  { 39, "ctrl_custom/Reference model1/Gain15/Gain", offsetof(P_ctrl_custom_T,
    Gain15_Gain), 19, 9, 2, 78, 0 },

  { 40, "ctrl_custom/Reference model1/Saturation/UpperLimit", offsetof
    (P_ctrl_custom_T, Saturation_UpperSat), 36, 1, 2, 80, 0 },

  { 41, "ctrl_custom/Reference model1/Saturation/LowerLimit", offsetof
    (P_ctrl_custom_T, Saturation_LowerSat), 36, 1, 2, 82, 0 },

  { 42, "ctrl_custom/Reference model1/Saturation2/UpperLimit", offsetof
    (P_ctrl_custom_T, Saturation2_UpperSat), 36, 1, 2, 84, 0 },

  { 43, "ctrl_custom/Reference model1/Saturation2/LowerLimit", offsetof
    (P_ctrl_custom_T, Saturation2_LowerSat), 36, 1, 2, 86, 0 },

  { 44, "ctrl_custom/Reference model1/Saturation3/UpperLimit", offsetof
    (P_ctrl_custom_T, Saturation3_UpperSat), 36, 1, 2, 88, 0 },

  { 45, "ctrl_custom/Reference model1/Saturation3/LowerLimit", offsetof
    (P_ctrl_custom_T, Saturation3_LowerSat), 36, 1, 2, 90, 0 },

  { 46, "ctrl_custom/Hold block/Memory/X0", offsetof(P_ctrl_custom_T,
    Memory_X0_o), 36, 1, 2, 92, 0 },

  { 47, "ctrl_custom/Hold block/Constant/Value", offsetof(P_ctrl_custom_T,
    Constant_Value_g), 36, 1, 2, 94, 0 },

  { 48, "ctrl_custom/SAXXIS input/Gain3/Gain", offsetof(P_ctrl_custom_T,
    Gain3_Gain), 36, 1, 2, 96, 0 },
};

static int32_t NI_ParamListSize DataSection(".NIVS.paramlistsize") = 49;
static int32_t NI_ParamDimList[] DataSection(".NIVS.paramdimlist") =
{
  3, 3,                                /* Parameter at index 0 */
  3, 3,                                /* Parameter at index 1 */
  3, 3,                                /* Parameter at index 2 */
  3, 3,                                /* Parameter at index 3 */
  1, 1,                                /* Parameter at index 4 */
  1, 1,                                /* Parameter at index 5 */
  1, 1,                                /* Parameter at index 6 */
  1, 1,                                /* Parameter at index 7 */
  1, 1,                                /* Parameter at index 8 */
  1, 1,                                /* Parameter at index 9 */
  1, 1,                                /* Parameter at index 10 */
  1, 1,                                /* Parameter at index 11 */
  1, 1,                                /* Parameter at index 12 */
  1, 1,                                /* Parameter at index 13 */
  1, 1,                                /* Parameter at index 14 */
  1, 1,                                /* Parameter at index 15 */
  1, 1,                                /* Parameter at index 16 */
  1, 1,                                /* Parameter at index 17 */
  1, 1,                                /* Parameter at index 18 */
  1, 1,                                /* Parameter at index 19 */
  1, 1,                                /* Parameter at index 20 */
  3, 1,                                /* Parameter at index 21 */
  1, 1,                                /* Parameter at index 22 */
  1, 1,                                /* Parameter at index 23 */
  1, 1,                                /* Parameter at index 24 */
  1, 1,                                /* Parameter at index 25 */
  1, 1,                                /* Parameter at index 26 */
  3, 1,                                /* Parameter at index 27 */
  1, 1,                                /* Parameter at index 28 */
  1, 1,                                /* Parameter at index 29 */
  3, 3,                                /* Parameter at index 30 */
  3, 3,                                /* Parameter at index 31 */
  3, 3,                                /* Parameter at index 32 */
  3, 3,                                /* Parameter at index 33 */
  1, 1,                                /* Parameter at index 34 */
  3, 3,                                /* Parameter at index 35 */
  1, 1,                                /* Parameter at index 36 */
  3, 3,                                /* Parameter at index 37 */
  3, 3,                                /* Parameter at index 38 */
  3, 3,                                /* Parameter at index 39 */
  1, 1,                                /* Parameter at index 40 */
  1, 1,                                /* Parameter at index 41 */
  1, 1,                                /* Parameter at index 42 */
  1, 1,                                /* Parameter at index 43 */
  1, 1,                                /* Parameter at index 44 */
  1, 1,                                /* Parameter at index 45 */
  1, 1,                                /* Parameter at index 46 */
  1, 1,                                /* Parameter at index 47 */
  1, 1,                                /* Parameter at index 48 */
};

static NI_Signal NI_SigList[] DataSection(".NIVS.siglist") =
{
  { 0, "ctrl_custom/Observer with bias/Integrator/(1, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Integrator) + (0*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0,
    0 },

  { 1, "ctrl_custom/Observer with bias/Integrator/(1, 2)", 0, "", offsetof
    (B_ctrl_custom_T, Integrator) + (1*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0,
    0 },

  { 2, "ctrl_custom/Observer with bias/Integrator/(1, 3)", 0, "", offsetof
    (B_ctrl_custom_T, Integrator) + (2*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0,
    0 },

  { 3, "ctrl_custom/Reference model1/Integrator2/(1, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Integrator2) + (0*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2,
    0, 0 },

  { 4, "ctrl_custom/Reference model1/Integrator2/(1, 2)", 0, "", offsetof
    (B_ctrl_custom_T, Integrator2) + (1*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2,
    0, 0 },

  { 5, "ctrl_custom/Reference model1/Integrator2/(1, 3)", 0, "", offsetof
    (B_ctrl_custom_T, Integrator2) + (2*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2,
    0, 0 },

  { 6, "ctrl_custom/Observer with bias/Integrator2/(1, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Integrator2_m) + (0*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2,
    0, 0 },

  { 7, "ctrl_custom/Observer with bias/Integrator2/(1, 2)", 0, "", offsetof
    (B_ctrl_custom_T, Integrator2_m) + (1*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2,
    0, 0 },

  { 8, "ctrl_custom/Observer with bias/Integrator2/(1, 3)", 0, "", offsetof
    (B_ctrl_custom_T, Integrator2_m) + (2*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2,
    0, 0 },

  { 9, "ctrl_custom/Pose/x_m", 0, "", offsetof(B_ctrl_custom_T, x_m) + (0*sizeof
    (real_T)), BLOCKIO_SIG, 0, 1, 2, 0, 0 },

  { 10, "ctrl_custom/Pose/y_m", 0, "", offsetof(B_ctrl_custom_T, y_m) + (0*
    sizeof(real_T)), BLOCKIO_SIG, 0, 1, 2, 0, 0 },

  { 11, "ctrl_custom/Pose/psi_m", 0, "", offsetof(B_ctrl_custom_T, psi_m) + (0*
    sizeof(real_T)), BLOCKIO_SIG, 0, 1, 2, 0, 0 },

  { 12, "ctrl_custom/Reference model1/Saturation8", 0, "", offsetof
    (B_ctrl_custom_T, Saturation8) + (0*sizeof(real_T)), BLOCKIO_SIG, 0, 1, 2, 0,
    0 },

  { 13, "ctrl_custom/Reference model1/Saturation6", 0, "", offsetof
    (B_ctrl_custom_T, Saturation6) + (0*sizeof(real_T)), BLOCKIO_SIG, 0, 1, 2, 0,
    0 },

  { 14, "ctrl_custom/Reference model1/Saturation7", 0, "", offsetof
    (B_ctrl_custom_T, Saturation7) + (0*sizeof(real_T)), BLOCKIO_SIG, 0, 1, 2, 0,
    0 },

  { 15, "ctrl_custom/Observer with bias/Integrator1/(1, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Integrator1) + (0*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2,
    0, 0 },

  { 16, "ctrl_custom/Observer with bias/Integrator1/(1, 2)", 0, "", offsetof
    (B_ctrl_custom_T, Integrator1) + (1*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2,
    0, 0 },

  { 17, "ctrl_custom/Observer with bias/Integrator1/(1, 3)", 0, "", offsetof
    (B_ctrl_custom_T, Integrator1) + (2*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2,
    0, 0 },

  { 18, "ctrl_custom/ PID /Sum6/(1, 1)", 0, "", offsetof(B_ctrl_custom_T, Sum6)
    + (0*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 19, "ctrl_custom/ PID /Sum6/(1, 2)", 0, "", offsetof(B_ctrl_custom_T, Sum6)
    + (1*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 20, "ctrl_custom/ PID /Sum6/(1, 3)", 0, "", offsetof(B_ctrl_custom_T, Sum6)
    + (2*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 21, "ctrl_custom/saturation/Saturation11", 0, "", offsetof(B_ctrl_custom_T,
    Saturation11) + (0*sizeof(real_T)), BLOCKIO_SIG, 0, 1, 2, 0, 0 },

  { 22, "ctrl_custom/saturation/Saturation1", 0, "", offsetof(B_ctrl_custom_T,
    Saturation1) + (0*sizeof(real_T)), BLOCKIO_SIG, 0, 1, 2, 0, 0 },

  { 23, "ctrl_custom/Freeze", 0, "", offsetof(B_ctrl_custom_T, Freeze) + (0*
    sizeof(real_T)), BLOCKIO_SIG, 0, 1, 2, 0, 0 },

  { 24, "ctrl_custom/Observer with bias/Gain/(1, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Gain) + (0*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 25, "ctrl_custom/Observer with bias/Gain/(2, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Gain) + (1*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 26, "ctrl_custom/Observer with bias/Gain/(3, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Gain) + (2*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 27, "ctrl_custom/Observer with bias/Gain/(1, 2)", 0, "", offsetof
    (B_ctrl_custom_T, Gain) + (3*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 28, "ctrl_custom/Observer with bias/Gain/(2, 2)", 0, "", offsetof
    (B_ctrl_custom_T, Gain) + (4*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 29, "ctrl_custom/Observer with bias/Gain/(3, 2)", 0, "", offsetof
    (B_ctrl_custom_T, Gain) + (5*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 30, "ctrl_custom/Observer with bias/Gain/(1, 3)", 0, "", offsetof
    (B_ctrl_custom_T, Gain) + (6*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 31, "ctrl_custom/Observer with bias/Gain/(2, 3)", 0, "", offsetof
    (B_ctrl_custom_T, Gain) + (7*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 32, "ctrl_custom/Observer with bias/Gain/(3, 3)", 0, "", offsetof
    (B_ctrl_custom_T, Gain) + (8*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 33, "ctrl_custom/Observer with bias/Gain1/(1, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Gain1) + (0*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 34, "ctrl_custom/Observer with bias/Gain1/(2, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Gain1) + (1*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 35, "ctrl_custom/Observer with bias/Gain1/(3, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Gain1) + (2*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 36, "ctrl_custom/Observer with bias/Gain1/(1, 2)", 0, "", offsetof
    (B_ctrl_custom_T, Gain1) + (3*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 37, "ctrl_custom/Observer with bias/Gain1/(2, 2)", 0, "", offsetof
    (B_ctrl_custom_T, Gain1) + (4*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 38, "ctrl_custom/Observer with bias/Gain1/(3, 2)", 0, "", offsetof
    (B_ctrl_custom_T, Gain1) + (5*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 39, "ctrl_custom/Observer with bias/Gain1/(1, 3)", 0, "", offsetof
    (B_ctrl_custom_T, Gain1) + (6*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 40, "ctrl_custom/Observer with bias/Gain1/(2, 3)", 0, "", offsetof
    (B_ctrl_custom_T, Gain1) + (7*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 41, "ctrl_custom/Observer with bias/Gain1/(3, 3)", 0, "", offsetof
    (B_ctrl_custom_T, Gain1) + (8*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 42, "ctrl_custom/Observer with bias/Gain2/(1, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Gain2) + (0*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 43, "ctrl_custom/Observer with bias/Gain2/(2, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Gain2) + (1*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 44, "ctrl_custom/Observer with bias/Gain2/(3, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Gain2) + (2*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 45, "ctrl_custom/Observer with bias/Gain2/(1, 2)", 0, "", offsetof
    (B_ctrl_custom_T, Gain2) + (3*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 46, "ctrl_custom/Observer with bias/Gain2/(2, 2)", 0, "", offsetof
    (B_ctrl_custom_T, Gain2) + (4*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 47, "ctrl_custom/Observer with bias/Gain2/(3, 2)", 0, "", offsetof
    (B_ctrl_custom_T, Gain2) + (5*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 48, "ctrl_custom/Observer with bias/Gain2/(1, 3)", 0, "", offsetof
    (B_ctrl_custom_T, Gain2) + (6*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 49, "ctrl_custom/Observer with bias/Gain2/(2, 3)", 0, "", offsetof
    (B_ctrl_custom_T, Gain2) + (7*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 50, "ctrl_custom/Observer with bias/Gain2/(3, 3)", 0, "", offsetof
    (B_ctrl_custom_T, Gain2) + (8*sizeof(real_T)), BLOCKIO_SIG, 19, 1, 2, 0, 0 },

  { 51, "ctrl_custom/Observer with bias/Sum3", 0, "", offsetof(B_ctrl_custom_T,
    Sum3) + (0*sizeof(real_T)), BLOCKIO_SIG, 0, 1, 2, 0, 0 },

  { 52, "ctrl_custom/Observer with bias/M/(1, 1)", 0, "", offsetof
    (B_ctrl_custom_T, M) + (0*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 53, "ctrl_custom/Observer with bias/M/(1, 2)", 0, "", offsetof
    (B_ctrl_custom_T, M) + (1*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 54, "ctrl_custom/Observer with bias/M/(1, 3)", 0, "", offsetof
    (B_ctrl_custom_T, M) + (2*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 55, "ctrl_custom/Observer with bias/Matrix Multiply2/(1, 1)", 0, "",
    offsetof(B_ctrl_custom_T, MatrixMultiply2) + (0*sizeof(real_T)), BLOCKIO_SIG,
    18, 1, 2, 0, 0 },

  { 56, "ctrl_custom/Observer with bias/Matrix Multiply2/(1, 2)", 0, "",
    offsetof(B_ctrl_custom_T, MatrixMultiply2) + (1*sizeof(real_T)), BLOCKIO_SIG,
    18, 1, 2, 0, 0 },

  { 57, "ctrl_custom/Observer with bias/Matrix Multiply2/(1, 3)", 0, "",
    offsetof(B_ctrl_custom_T, MatrixMultiply2) + (2*sizeof(real_T)), BLOCKIO_SIG,
    18, 1, 2, 0, 0 },

  { 58, "ctrl_custom/Observer with bias/Sum/(1, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Sum) + (0*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 59, "ctrl_custom/Observer with bias/Sum/(1, 2)", 0, "", offsetof
    (B_ctrl_custom_T, Sum) + (1*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 60, "ctrl_custom/Observer with bias/Sum/(1, 3)", 0, "", offsetof
    (B_ctrl_custom_T, Sum) + (2*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 61, "ctrl_custom/Reference model1/Gain/(1, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Gain_d) + (0*sizeof(real_T)), BLOCKIO_SIG, 22, 1, 2, 0, 0
  },

  { 62, "ctrl_custom/Reference model1/Gain/(2, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Gain_d) + (1*sizeof(real_T)), BLOCKIO_SIG, 22, 1, 2, 0, 0
  },

  { 63, "ctrl_custom/Reference model1/Gain/(3, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Gain_d) + (2*sizeof(real_T)), BLOCKIO_SIG, 22, 1, 2, 0, 0
  },

  { 64, "ctrl_custom/Reference model1/Sum1/(1, 1)", 0, "", offsetof
    (B_ctrl_custom_T, Sum1) + (0*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 65, "ctrl_custom/Reference model1/Sum1/(1, 2)", 0, "", offsetof
    (B_ctrl_custom_T, Sum1) + (1*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 66, "ctrl_custom/Reference model1/Sum1/(1, 3)", 0, "", offsetof
    (B_ctrl_custom_T, Sum1) + (2*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 67, "ctrl_custom/DP//manual", 0, "", offsetof(B_ctrl_custom_T, DPmanual) +
    (0*sizeof(real_T)), BLOCKIO_SIG, 0, 1, 2, 0, 0 },

  { 68, "ctrl_custom/Hold block/Sum", 0, "", offsetof(B_ctrl_custom_T, Sum_b) +
    (0*sizeof(real_T)), BLOCKIO_SIG, 0, 1, 2, 0, 0 },

  { 69, "ctrl_custom/SAXXIS input/L2", 0, "", offsetof(B_ctrl_custom_T, L2) + (0*
    sizeof(real_T)), BLOCKIO_SIG, 0, 1, 2, 0, 0 },

  { 70, "ctrl_custom/SAXXIS input/LstickR//L", 0, "", offsetof(B_ctrl_custom_T,
    LstickRL) + (0*sizeof(real_T)), BLOCKIO_SIG, 0, 1, 2, 0, 0 },

  { 71, "ctrl_custom/SAXXIS input/LstickU//D", 0, "", offsetof(B_ctrl_custom_T,
    LstickUD) + (0*sizeof(real_T)), BLOCKIO_SIG, 0, 1, 2, 0, 0 },

  { 72, "ctrl_custom/SAXXIS input/R2", 0, "", offsetof(B_ctrl_custom_T, R2) + (0*
    sizeof(real_T)), BLOCKIO_SIG, 0, 1, 2, 0, 0 },

  { 73, "ctrl_custom/Multiport Switch1/(1, 1)", 0, "", offsetof(B_ctrl_custom_T,
    MultiportSwitch1) + (0*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 74, "ctrl_custom/Multiport Switch1/(1, 2)", 0, "", offsetof(B_ctrl_custom_T,
    MultiportSwitch1) + (1*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 75, "ctrl_custom/Multiport Switch1/(1, 3)", 0, "", offsetof(B_ctrl_custom_T,
    MultiportSwitch1) + (2*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 76, "ctrl_custom/loss of signal 1", 1, "(1, 1)", offsetof(B_ctrl_custom_T,
    eta_out) + (0*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 77, "ctrl_custom/loss of signal 1", 1, "(1, 2)", offsetof(B_ctrl_custom_T,
    eta_out) + (1*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 78, "ctrl_custom/loss of signal 1", 1, "(1, 3)", offsetof(B_ctrl_custom_T,
    eta_out) + (2*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 79,
    "ctrl_custom/Rectangle coordinate thrust allocation/Rectangle coordinate thrust allocation",
    0, "", offsetof(B_ctrl_custom_T, u_1) + (0*sizeof(real_T)), BLOCKIO_SIG, 0,
    1, 2, 0, 0 },

  { 80,
    "ctrl_custom/Rectangle coordinate thrust allocation/Rectangle coordinate thrust allocation",
    3, "", offsetof(B_ctrl_custom_T, alpha_1) + (0*sizeof(real_T)), BLOCKIO_SIG,
    0, 1, 2, 0, 0 },

  { 81,
    "ctrl_custom/Rectangle coordinate thrust allocation/Rectangle coordinate thrust allocation",
    4, "", offsetof(B_ctrl_custom_T, alpha_2) + (0*sizeof(real_T)), BLOCKIO_SIG,
    0, 1, 2, 0, 0 },

  { 82, "ctrl_custom/MATLAB Function2", 0, "(1, 1)", offsetof(B_ctrl_custom_T,
    eta_out_n) + (0*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 83, "ctrl_custom/MATLAB Function2", 0, "(1, 2)", offsetof(B_ctrl_custom_T,
    eta_out_n) + (1*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 84, "ctrl_custom/MATLAB Function2", 0, "(1, 3)", offsetof(B_ctrl_custom_T,
    eta_out_n) + (2*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 85, "ctrl_custom/Hold block/Switch_function", 0, "", offsetof
    (B_ctrl_custom_T, switch_signal) + (0*sizeof(real_T)), BLOCKIO_SIG, 0, 1, 2,
    0, 0 },

  { 86, "ctrl_custom/Observer with bias/NED -> BODY1", 0, "(1, 1)", offsetof
    (B_ctrl_custom_T, sf_NEDBODY1_m.y) + (0*sizeof(real_T)), BLOCKIO_SIG, 18, 1,
    2, 0, 0 },

  { 87, "ctrl_custom/Observer with bias/NED -> BODY1", 0, "(1, 2)", offsetof
    (B_ctrl_custom_T, sf_NEDBODY1_m.y) + (1*sizeof(real_T)), BLOCKIO_SIG, 18, 1,
    2, 0, 0 },

  { 88, "ctrl_custom/Observer with bias/NED -> BODY1", 0, "(1, 3)", offsetof
    (B_ctrl_custom_T, sf_NEDBODY1_m.y) + (2*sizeof(real_T)), BLOCKIO_SIG, 18, 1,
    2, 0, 0 },

  { 89, "ctrl_custom/Observer with bias/NED -> BODY", 0, "(1, 1)", offsetof
    (B_ctrl_custom_T, sf_NEDBODY.y) + (0*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2,
    0, 0 },

  { 90, "ctrl_custom/Observer with bias/NED -> BODY", 0, "(1, 2)", offsetof
    (B_ctrl_custom_T, sf_NEDBODY.y) + (1*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2,
    0, 0 },

  { 91, "ctrl_custom/Observer with bias/NED -> BODY", 0, "(1, 3)", offsetof
    (B_ctrl_custom_T, sf_NEDBODY.y) + (2*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2,
    0, 0 },

  { 92, "ctrl_custom/NED -> BODY1", 0, "(1, 1)", offsetof(B_ctrl_custom_T,
    sf_NEDBODY1.y) + (0*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 93, "ctrl_custom/NED -> BODY1", 0, "(1, 2)", offsetof(B_ctrl_custom_T,
    sf_NEDBODY1.y) + (1*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { 94, "ctrl_custom/NED -> BODY1", 0, "(1, 3)", offsetof(B_ctrl_custom_T,
    sf_NEDBODY1.y) + (2*sizeof(real_T)), BLOCKIO_SIG, 18, 1, 2, 0, 0 },

  { -1, "", -1, "", 0, 0, 0 }
};

static int32_t NI_SigListSize DataSection(".NIVS.siglistsize") = 95;
static int32_t NI_VirtualBlockSources[1];
static int32_t NI_SigDimList[] DataSection(".NIVS.sigdimlist") =
{ 1, 1
};

static int32_t NI_ExtListSize DataSection(".NIVS.extlistsize") = 44;
static NI_ExternalIO NI_ExtList[] DataSection(".NIVS.extlist") =
{
  { 1, "Pose/x_m", 0, EXT_IN, 1, 1, 1 },

  { 2, "Pose/y_m", 0, EXT_IN, 1, 1, 1 },

  { 3, "Pose/psi_m", 0, EXT_IN, 1, 1, 1 },

  { 4, "Freeze", 0, EXT_IN, 1, 1, 1 },

  { 5, "DP//manual", 1, EXT_IN, 1, 1, 1 },

  { 6, "SAXXIS input/L2", 1, EXT_IN, 1, 1, 1 },

  { 7, "SAXXIS input/LstickR//L", 1, EXT_IN, 1, 1, 1 },

  { 8, "SAXXIS input/LstickU//D", 1, EXT_IN, 1, 1, 1 },

  { 9, "SAXXIS input/R2", 1, EXT_IN, 1, 1, 1 },

  { 1, "beta_est/bpsi_est", 0, EXT_OUT, 1, 1, 1 },

  { 2, "beta_est/bx_est", 0, EXT_OUT, 1, 1, 1 },

  { 3, "beta_est/by_est", 0, EXT_OUT, 1, 1, 1 },

  { 4, "eta/QTM_SCOPEPSI", 0, EXT_OUT, 1, 1, 1 },

  { 5, "eta/QTM_SCOPEX", 0, EXT_OUT, 1, 1, 1 },

  { 6, "eta/QTM_SCOPEY", 0, EXT_OUT, 1, 1, 1 },

  { 7, "eta_d/psi_d", 0, EXT_OUT, 1, 1, 1 },

  { 8, "eta_d/x_d", 0, EXT_OUT, 1, 1, 1 },

  { 9, "eta_d/y_d", 0, EXT_OUT, 1, 1, 1 },

  { 10, "eta_est/psi_est", 0, EXT_OUT, 1, 1, 1 },

  { 11, "eta_est/x_est", 0, EXT_OUT, 1, 1, 1 },

  { 12, "eta_est/y_est", 0, EXT_OUT, 1, 1, 1 },

  { 13, "nu/r", 0, EXT_OUT, 1, 1, 1 },

  { 14, "nu/u", 0, EXT_OUT, 1, 1, 1 },

  { 15, "nu/v", 0, EXT_OUT, 1, 1, 1 },

  { 16, "nu_d/omega_d", 0, EXT_OUT, 1, 1, 1 },

  { 17, "nu_d/u_d", 0, EXT_OUT, 1, 1, 1 },

  { 18, "nu_d/v_d", 0, EXT_OUT, 1, 1, 1 },

  { 19, "nu_est/r_est", 0, EXT_OUT, 1, 1, 1 },

  { 20, "nu_est/u_est", 0, EXT_OUT, 1, 1, 1 },

  { 21, "nu_est/v_est", 0, EXT_OUT, 1, 1, 1 },

  { 22, "u/alpha_VSP1", 0, EXT_OUT, 1, 1, 1 },

  { 23, "u/alpha_VSP2", 0, EXT_OUT, 1, 1, 1 },

  { 24, "u/u_BT", 0, EXT_OUT, 1, 1, 1 },

  { 25, "u/u_VSP1", 0, EXT_OUT, 1, 1, 1 },

  { 26, "u/u_VSP2", 0, EXT_OUT, 1, 1, 1 },

  { 27, "u/omega_VSP1", 1, EXT_OUT, 1, 1, 1 },

  { 28, "u/omega_VSP2", 1, EXT_OUT, 1, 1, 1 },

  { 29, " PID /tau_pid /tau3", 0, EXT_OUT, 1, 1, 1 },

  { 30, " PID /tau_pid /tau1", 0, EXT_OUT, 1, 1, 1 },

  { 31, " PID /tau_pid /tau2", 0, EXT_OUT, 1, 1, 1 },

  { 32, "DP//manualOut", 1, EXT_OUT, 1, 1, 1 },

  { 33, "tau_cmd/Tau_cmd_surge", 1, EXT_OUT, 1, 1, 1 },

  { 34, "tau_cmd/Tau_cmd_sway", 1, EXT_OUT, 1, 1, 1 },

  { 35, "tau_cmd/Tau_cmd_yaw", 1, EXT_OUT, 1, 1, 1 },

  { -1, "", 0, 0, 0, 0, 0 }
};

/* This Task List is generated to allow access to the task specs without
 * initializing the model.
 * 0th entry is for scheduler (base rate)
 * rest for multirate model's tasks.
 */
NI_Task NI_TaskList[] DataSection(".NIVS.tasklist") =
{
  { 0, 0.01, 0 }
};

int32_t NI_NumTasks DataSection(".NIVS.numtasks") = 1;
static const char* NI_CompiledModelName DataSection(".NIVS.compiledmodelname") =
  "ctrl_custom";
static const char* NI_CompiledModelVersion = "1.290";
static const char* NI_CompiledModelDateTime = "Tue May 28 15:35:15 2019";
static const char* NI_builder DataSection(".NIVS.builder") =
  "NI Model Framework 2017.0.0.143 (2017) for Simulink Coder 8.11 (R2016b)";
static const char* NI_BuilderVersion DataSection(".NIVS.builderversion") =
  "2017.0.0.143";

/*========================================================================*
 * Function: NIRT_GetBuildInfo
 *
 * Abstract:
 *	Get the DLL versioning etc information.
 *
 * Output Parameters:
 *	detail	: String containing model build information.
 *	len		: the build info string length. If a value of "-1" is specified, the minimum buffer size of "detail" is returned as its value.
 *
 * Returns:
 *	NI_OK if no error
 *========================================================================*/
DLL_EXPORT int32_t NIRT_GetBuildInfo(char* detail, int32_t* len)
{
  int32_t msgLength = 0;
  char *msgBuffer = NULL;

  /* Message */
  const char msg[] =
    "%s\nModel Name: %s\nModel Version: %s\nVeriStand Model Framework Version: %s\nCompiled On: %s";

  /* There are no console properties to set for VxWorks, because the console is simply serial output data.
     Just do printf for VxWorks and ignore all console properties. */
#if ! defined (VXWORKS) && ! defined (kNIOSLinux)

  HANDLE hStdout = GetStdHandle(STD_OUTPUT_HANDLE);
  SetConsoleTextAttribute(hStdout, FOREGROUND_INTENSITY | FOREGROUND_BLUE |
    FOREGROUND_GREEN | FOREGROUND_RED);

#endif

  /* Print to screen */
  printf("\n*******************************************************************************\n");
  msgLength = printf(msg, NI_builder, NI_CompiledModelName,
                     NI_CompiledModelVersion, NI_BuilderVersion,
                     NI_CompiledModelDateTime);
  printf("\n*******************************************************************************\n");

#if ! defined (VXWORKS) && ! defined (kNIOSLinux)

  SetConsoleTextAttribute(hStdout, FOREGROUND_BLUE | FOREGROUND_GREEN |
    FOREGROUND_RED);

#endif

  if (*len == -1) {
    /* Return the required minimum buffer size */
    *len = msgLength;
  } else {
    /* allocate the buffer */
    msgBuffer = (char*)calloc(msgLength + 1, sizeof(char));
    sprintf (msgBuffer, msg, NI_builder, NI_CompiledModelName,
             NI_CompiledModelVersion, NI_BuilderVersion,
             NI_CompiledModelDateTime);
    if (*len >= msgLength) {
      *len = msgLength + 1;
    }

    /* Copy into external buffer */
    strncpy(detail, msgBuffer, *len);

    /* Release memory */
    free(msgBuffer);
  }

  return NI_OK;
}

/*========================================================================*
 * Function: NIRT_GetSignalSpec
 *
 * Abstract:
 *	If index == -1, lookup parameter by the ID.
 *	If ID_len == 0 or if ID == null, return number of parameters in model.
 *	Otherwise, lookup parameter by index, and return the information.
 *
 * Input/Output Parameters:
 *	index		: index of the signal (in/out)
 *	ID			: ID of signal to be looked up (in), ID of signal at index (out)
 *	ID_len		: length of input ID(in), length of ID (out)
 *	bnlen		: length of buffer blkname (in), length of output blkname (out)
 *	snlen		: length of buffer signame (in), length of output signame (out)
 *
 * Output Parameters:
 *	blkname		: Name of the source block for the signal
 *	portnum		: port number of the block that is the source of the signal (0 indexed)
 *	signame		: Name of the signal
 *	datatype	: same as with parameters. Currently assuming all data to be double.
 *	dims		: The port's dimension of length 'numdims'.
 *	numdims		: the port's number of dimensions. If a value of "-1" is specified, the minimum buffer size of "dims" is returned as its value.
 *
 * Returns:
 *	NI_OK if no error(if sigidx == -1, number of signals)
 *========================================================================*/
DLL_EXPORT int32_t NIRT_GetSignalSpec(int32_t* sidx, char* ID, int32_t* ID_len,
  char* blkname, int32_t *bnlen,
  int32_t *portnum, char* signame, int32_t *snlen, int32_t *dattype, int32_t*
  dims, int32_t* numdim)
{
  int32_t sigidx = *sidx;
  int32_t i = 0;
  char *addr = NULL;
  char *IDblk = 0;
  int32_t IDport = 0;
  if (sigidx < 0) {
    /* check if ID has been specified. */
    if ((ID != NULL) && (ID_len != NULL) && (*ID_len > 0)) {
      /* parse ID into blkname and port */
      addr = strrchr(ID, ':');
      if (addr == NULL) {
        return NI_SigListSize;
      }

      /* Calculate the char offset into the string after the port */
      i = addr - ID;

      /* malformed ID */
      if (i<=0) {
        return NI_SigListSize;
      }

      IDblk = ID;
      IDport = atoi(ID+i+1);

      /* lookup the table for matching ID */
      for (i=0; i<NI_SigListSize; i++) {
        /* 11 to accomodate ':','/', port number and null character */
        char *tempID = (char *)calloc(strlen(NI_SigList[i].blockname)+strlen
          (NI_SigList[i].signalname) + 11, sizeof(char));
        if (strlen(NI_SigList[i].signalname)>0) {
          sprintf(tempID,"%s:%d%s%s",NI_SigList[i].blockname,NI_SigList[i].
                  portno+1,"/",NI_SigList[i].signalname);
        } else {
          sprintf(tempID,"%s:%d",NI_SigList[i].blockname,NI_SigList[i].portno+1);
        }

        if (!strcmp(IDblk,tempID) && IDport==(NI_SigList[i].portno+1)) {
          break;
        }

        free(tempID);
      }

      if (i < NI_SigListSize) {
        sigidx = *sidx = i;
      } else {
        return NI_SigListSize;
      }
    } else {
      // no index or ID specified.
      return NI_SigListSize;
    }
  }

  if (sigidx>=0 && sigidx<NI_SigListSize) {
    if (ID != NULL) {
      // no need for return string to be null terminated!
      /* 11 to accomodate ':','/', port number and null character */
      char *tempID = (char *)calloc(strlen(NI_SigList[sigidx].blockname)+strlen
        (NI_SigList[sigidx].signalname)+ 11, sizeof(char));
      if (strlen(NI_SigList[sigidx].signalname)>0) {
        sprintf(tempID,"%s:%d%s%s",NI_SigList[sigidx].blockname,
                NI_SigList[sigidx].portno+1,"/",NI_SigList[sigidx].signalname);
      } else {
        sprintf(tempID,"%s:%d",NI_SigList[sigidx].blockname,NI_SigList[sigidx].
                portno+1);
      }

      if ((int32_t)strlen(tempID)<*ID_len) {
        *ID_len = strlen(tempID);
      }

      strncpy(ID, tempID, *ID_len);
      free(tempID);
    }

    if (blkname != NULL) {
      // no need for return string to be null terminated!
      if ((int32_t)strlen(NI_SigList[sigidx].blockname)<*bnlen) {
        *bnlen = strlen(NI_SigList[sigidx].blockname);
      }

      strncpy(blkname, NI_SigList[sigidx].blockname, *bnlen);
    }

    if (signame != NULL) {
      // no need for return string to be null terminated!
      if ((int32_t)strlen(NI_SigList[sigidx].signalname)<*snlen) {
        *snlen = strlen(NI_SigList[sigidx].signalname);
      }

      strncpy(signame, NI_SigList[sigidx].signalname, *snlen);
    }

    if (portnum != NULL) {
      *portnum = NI_SigList[sigidx].portno;
    }

    if (dattype != NULL) {
      *dattype = NI_SigList[sigidx].datatype;
    }

    if (numdim != NULL) {
      if (*numdim == -1) {
        *numdim = NI_SigList[sigidx].numofdims;
      } else if (dims != NULL) {
        for (i=0;i < *numdim; i++) {
          dims[i] = NI_SigDimList[NI_SigList[sigidx].dimListOffset +i];
        }
      }
    }

    return NI_OK;
  }

  return NI_SigListSize;
}

/*========================================================================*
 * Function: NIRT_GetParameterIndices
 *
 * Abstract:
 *	Returns an array of indices to tunable parameters
 *
 * Output Parameters:
 *	indices	: buffer to store the parameter indices of length "len"
 *	len		: returns the number of indices. If a value of "-1" is specified, the minimum buffer size of "indices" is returned as its value.
 *
 * Returns:
 *	NI_OK if no error
 *========================================================================*/
DLL_EXPORT int32_t NIRT_GetParameterIndices(int32_t* indices, int32_t* len)
{
  int32_t i;
  if ((len == NULL) || (indices == NULL)) {
    return NI_ERROR;
  }

  if (*len == -1) {
    *len = NI_ParamListSize;
  } else {
    for (i=0; (i < NI_ParamListSize) && (i < *len); i++) {
      indices[i] = NI_ParamList[i].idx;
    }

    *len = i;
  }

  return NI_OK;
}

/*========================================================================*
 * Function: NIRT_GetParameterSpec
 *
 * Abstract:
 *	If index == -1, lookup parameter by the ID.
 *	If ID_len == 0 or if ID == null, return number of parameters in model.
 *	Otherwise, lookup parameter by index, and return the information.
 *
 * Input/Output Parameters:
 *	paramidx	: index of the parameter(in/out). If a value of "-1" is specified, the parameter's ID is used instead
 *	ID			: ID of parameter to be looked up (in), ID of parameter at index (out)
 *	ID_len		: length of input ID (in), length of ID (out)
 *	pnlen		: length of buffer paramname(in), length of the returned paramname (out)
 *	numdim		: length of buffer dimension(in), length of output dimension (out). If a value of "-1" is specified, the minimum buffer size of "dims" is returned as its value
 *
 * Output Parameters:
 *	paramname	: Name of the parameter
 *	datatype	: datatype of the parameter (currently assuming 0: double, .. )
 *	dims		: array of dimensions with length 'numdim'
 *
 * Returns:
 *	NI_OK if no error (if paramidx == -1, number of tunable parameters)
 *========================================================================*/
DLL_EXPORT int32_t NIRT_GetParameterSpec(int32_t* pidx, char* ID, int32_t*
  ID_len, char* paramname, int32_t *pnlen,
  int32_t *dattype, int32_t* dims, int32_t* numdim)
{
  int32_t i = 0;
  int32_t paramidx = *pidx;
  if (paramidx < 0) {
    // check if ID has been specified.
    if ((ID != NULL) && (ID_len != NULL) && (*ID_len > 0) ) {
      // lookup the table for matching ID
      for (i=0; i < NI_ParamListSize; i++) {
        if (strcmp(ID,NI_ParamList[i].paramname) == 0) {
          /* found matching string */
          break;
        }
      }

      if (i < NI_ParamListSize) {
        /* note the index into the rtParamAttribs */
        paramidx = *pidx = i;
      } else {
        return NI_ParamListSize;
      }
    } else {
      // no index or ID specified.
      return NI_ParamListSize;
    }
  }

  if ((paramidx >= 0) && (paramidx<NI_ParamListSize)) {
    if (ID != NULL) {
      if ((int32_t)strlen(NI_ParamList[paramidx].paramname) < *ID_len) {
        *ID_len = strlen(NI_ParamList[paramidx].paramname);
      }

      strncpy(ID, NI_ParamList[paramidx].paramname, *ID_len);
    }

    if (paramname != NULL) {
      /* no need for return string to be null terminated! */
      if ((int32_t)strlen(NI_ParamList[paramidx].paramname) < *pnlen) {
        *pnlen = strlen(NI_ParamList[paramidx].paramname);
      }

      strncpy(paramname, NI_ParamList[paramidx].paramname, *pnlen);
    }

    if (dattype != NULL) {
      *dattype = NI_ParamList[paramidx].datatype;
    }

    if (numdim != NULL) {
      if (*numdim == -1) {
        *numdim = NI_ParamList[paramidx].numofdims;
      } else if (dims != NULL) {
        for (i = 0; i < *numdim; i++) {
          dims[i] = NI_ParamDimList[NI_ParamList[paramidx].dimListOffset + i];
        }
      }
    }

    return NI_OK;
  }

  return NI_ParamListSize;
}

/*========================================================================*
 * Function: NIRT_GetExtIOSpec
 *
 * Abstract:
 *	Returns the model's inport or outport specification
 *
 * Input Parameters:
 *	index	: index of the task
 *
 * Output Parameters:
 *	idx		: idx of the IO.
 *	name	: Name of the IO block
 *	tid		: task id
 *	type	: EXT_IN or EXT_OUT
 *	dims	: The port's dimension of length 'numdims'.
 *	numdims : the port's number of dimensions. If a value of "-1" is specified, the minimum buffer size of "dims" is returned as its value.
 *
 * Returns
 *	NI_OK if no error. (if index == -1, return number of tasks in the model)
 *========================================================================*/
DLL_EXPORT int32_t NIRT_GetExtIOSpec(int32_t index, int32_t *idx, char* name,
  int32_t* tid, int32_t *type, int32_t *dims, int32_t* numdims)
{
  if (index == -1) {
    return NI_ExtListSize;
  }

  if (idx != NULL) {
    *idx = NI_ExtList[index].idx;
  }

  if (name != NULL) {
    int32_t sz = strlen(name);
    strncpy(name, NI_ExtList[index].name, sz-1);
    name[sz-1]= 0;
  }

  if (tid != NULL) {
    *tid = NI_ExtList[index].TID;
  }

  if (type != NULL) {
    *type = NI_ExtList[index].type;
  }

  if (numdims != NULL) {
    if (*numdims == -1) {
      *numdims = 2;
    } else if (numdims != NULL) {
      /* Return port dimensions */
      dims[0] = NI_ExtList[index].dimX;
      dims[1] = NI_ExtList[index].dimY;
    }
  }

  return NI_OK;
}

/*========================================================================*
 * Function: NI_ProbeOneSignal
 *
 * Abstract:
 *		Helper function to probe one signal. baseaddr must NOT be VIRTUAL_SIG
 *
 * Output Parameters
 *
 * Returns:
 *     Return value: Returns the last index value probed in a vector signal
 *========================================================================*/
static int32_t NI_ProbeOneSignal(int32_t idx, double *value, int32_t len,
  int32_t *count, int32_t vOffset, int32_t vLength)
{
  if (NI_SigList[idx].baseaddr == VIRTUAL_SIG) {
    SetSITErrorMessage("NI_ProbeOneSignal: Received request to probe a virtual signal, but was expecting a ground source. Ignoring virtual signal probe. Report this behavior to National Instruments.",
                       0);
    return 0;
  } else {
    char *ptr = (char*)((NI_SigList[idx].baseaddr == BLOCKIO_SIG) ? S->blockIO :
                        S->inputs) + (uintptr_t)NI_SigList[idx].addr;
    int32_t subindex = (vLength == -1) ? 0 : vOffset;
    int32_t sublength = (vLength == -1) ? NI_SigList[idx].width : (vLength +
      vOffset);
    while ((subindex < sublength) && (*count < len))
      value[(*count)++] = NIRT_GetValueByDataType(ptr, subindex++,
        NI_SigList[idx].datatype, NI_SigList[idx].IsComplex);
    return *count;
  }
}

/*========================================================================*
 * Function: NIRT_ProbeSignals
 *
 * Abstract:
 *	returns the latest signal values.
 *
 * Input Parameters:
 *	sigindices	: list of signal indices to be probed.
 *	numsigs		: length of sigindices array.
 *
 *		NOTE: (Implementation detail) the sigindices array that is passed in is delimited by a value of -1.
 *		Thus the # of valid indices in the sigindices table is min(numsigs, index of value -1) - 1.
 *		Reason for subtracting 1, the first index in the array is used for bookkeeping and should be copied
 *		into the 0th index in the signal values buffer.
 *		Also, the 1st index in the signal values buffer should contain the current timestamp. Hence valid
 *		signal data should be filled in starting from index 2. Any non-scalar signals should be added to the
 *		buffer in row-order.
 *
 * Input/Output Parameters
 *	num			: (in) length of sigvalues buffer (out) number of values returned in the buffer
 *
 * Output Parameters:
 *	value		: array of signal values
 *
 * Returns:
 *	NI_OK if no error
 *========================================================================*/
DLL_EXPORT int32_t NIRT_ProbeSignals(int32_t* sigindices, int32_t numsigs,
  double* value, int32_t* len)
{
  int32_t i = 0;
  int32_t idx = 0;
  int32_t count = 0;
  if (!SITexportglobals.inCriticalSection) {
    SetSITErrorMessage("SignalProbe should only be called between ScheduleTasks and PostOutputs",
                       1);
  }

  /* Get the index to the first signal */
  if ((*len > 1) && (numsigs > 0)) {
    value[count++] = sigindices[0];
    value[count++] = 0;
  }

  /* Get the second and other signals */
  for (i = 1; (i < numsigs) && (count < *len); i++) {
    idx = sigindices[i];
    if (idx < 0) {
      break;
    }

    if (idx < NI_SigListSize) {
      if (NI_SigList[idx].baseaddr == VIRTUAL_SIG) {
        int32_t vidx = NI_VirtualBlockSources[NI_SigList[idx].addr];
        NI_ProbeOneSignal(vidx, value, *len, &count, 0, -1);
      } else {
        NI_ProbeOneSignal(idx, value, *len, &count, 0, -1);
      }
    }
  }

  *len = count;
  return count;
}

int32_t NI_InitializeParamStruct()
{
  memcpy(&rtParameter[0], &ctrl_custom_P, sizeof(P_ctrl_custom_T));
  return NI_OK;
}

/*  After the model has initialized and updated the parameters in
   rtParameter[0] (aka ctrl_custom_P) we make a copy to rtParameter[1] so
   that it is double buffered. We also do a memcpy to each task's copy.
 */
int32_t NI_InitParamDoubleBuf()
{
  int32_t idx = 1;

#ifdef MULTITASKING

  for (; idx <= NUMST - TID01EQ; idx++)
#endif

    memcpy(&rtParameter[idx], &rtParameter[0], sizeof(P_ctrl_custom_T));
  return NI_OK;
}

static int32_t NI_SetParamTxStatus = NI_OK;

/*========================================================================*
 * Function: NIRT_SetParameter
 *
 * Abstract:
 *	Set parameter value. Called either in scheduler loop or a background loop.
 *
 * Input Parameters:
 *	index	: index of the parameter (as specified in Parameter Information)
 *	subindex: index in the flattened array, if parameter is n-D array
 *	val		: Value to set the parameter to
 *
 * Returns:
 *	NI_OK if no error
 *========================================================================*/
DLL_EXPORT int32_t NIRT_SetParameter(int32_t index, int32_t subindex, double
  value)
{
  char* ptr = NULL;

  /* Check bounds */
  if (index >= NI_ParamListSize) {
    SetSITErrorMessage("Parameter index is out of bounds.", 1);
    return NI_SetParamTxStatus= NI_ERROR;
  }

  /* Commit parameter values */
  if (index < 0) {
    if (ReadSideDirtyFlag == 1) {
      memcpy(&rtParameter[1-READSIDE], &rtParameter[READSIDE], sizeof
             (P_ctrl_custom_T));
      ReadSideDirtyFlag = 0;
      if (WriteSideDirtyFlag == 0) {
        /* No values to commit */
        return NI_OK;
      } else {
        SetSITErrorMessage("Parameters have been set inline and from the background loop at the same time. Parameters written from the background loop since the last commit have been lost.",
                           1);
        WriteSideDirtyFlag = 0;
        return NI_ERROR;
      }
    }

    /* If an error occurred and we have values to commit, then save to the write side and return error */
    if (NI_SetParamTxStatus == NI_ERROR) {
      // fail the transaction.
      // copy old list of parameters to the failed TX buffer
      if (WriteSideDirtyFlag == 1) {
        memcpy(&rtParameter[READSIDE], &rtParameter[1-READSIDE], sizeof
               (P_ctrl_custom_T));
      }

      // reset the status.
      NI_SetParamTxStatus = NI_OK;
      WriteSideDirtyFlag = 0;
      return NI_ERROR;
    }

    /* If we have values to commit, then save to the write-side */
    if (WriteSideDirtyFlag == 1) {
      S->defaultParam = (double *)&rtParameter[1-READSIDE];
      WaitForSingleObject(SITexportglobals.flipCriticalSection, INFINITE);
      READSIDE = 1 - READSIDE;
      SITexportglobals.copyTaskBitfield = 0xFFFFFFFF;
      ReleaseSemaphore(SITexportglobals.flipCriticalSection, 1, NULL);

      // Copy back the newly set parameters to the writeside.
      memcpy(&rtParameter[1-READSIDE], &rtParameter[READSIDE], sizeof
             (P_ctrl_custom_T));
      WriteSideDirtyFlag = 0;
    }

    return NI_OK;
  }

  // verify that subindex is within bounds.
  if (subindex >= NI_ParamList[index].width) {
    SetSITErrorMessage("Parameter subindex is out of bounds.",1);
    return NI_SetParamTxStatus = NI_ERROR;
  }

  if (ReadSideDirtyFlag == 1) {
    memcpy(&rtParameter[1-READSIDE], &rtParameter[READSIDE], sizeof
           (P_ctrl_custom_T));
    ReadSideDirtyFlag = 0;
  }

  /* Get the parameter's address into the Parameter struct
     casting to char to perform pointer arithmetic using the byte offset */
  ptr = (char *)(&rtParameter[1-READSIDE]) + NI_ParamList[index].addr;
  WriteSideDirtyFlag = 1;

  /* Convert the incoming double datatype to the parameter's internal datatype and update value */
  return NIRT_SetValueByDataType(ptr, subindex, value, NI_ParamList[index].
    datatype, NI_ParamList[index].IsComplex);
}

/*========================================================================*
 * Function: NIRT_SetVectorParameter
 *
 * Abstract:
 *	Sets the value to a parameter array.
 *
 * Input Parameters:
 *	index		: index of the parameter as returned by NIRT_GetParameterSpec()
 *	paramvalues	: array of values to set
 *	paramlength	: Length of parameter values.
 *
 * Returns:
 *	NI_OK if no error
 *========================================================================*/
DLL_EXPORT int32_t NIRT_SetVectorParameter( uint32_t index, const double
  * paramvalues, uint32_t paramlength)
{
  uint32_t i = 0;
  int32_t retval = NI_OK;
  char* ptr = NULL;

  /* verify that index is within bounds*/
  if (index >= (uint32_t)NI_ParamListSize) {
    SetSITErrorMessage("Parameter index is out of bounds.", 1);
    return NI_SetParamTxStatus = NI_ERROR;
  }

  // verify that subindex is within bounds.
  if (paramlength != (uint32_t)NI_ParamList[index].width) {
    SetSITErrorMessage("Parameter length is incorrect.", 1);
    return NI_SetParamTxStatus = NI_ERROR;
  }

  /* If we have pending modified parameters, then copy to write-side */
  if (ReadSideDirtyFlag == 1) {
    memcpy(&rtParameter[1-READSIDE], &rtParameter[READSIDE], sizeof
           (P_ctrl_custom_T));
    ReadSideDirtyFlag = 0;
  }

  /* Get the parameter's address into the Parameter struct
     casting to char to perform pointer arithmetic using the byte offset */
  ptr = (char*)(&rtParameter[1-READSIDE]) + NI_ParamList[index].addr;
  while (i < paramlength) {
    /* Convert the incoming double datatype to the parameter's internal datatype and update value */
    retval = retval & NIRT_SetValueByDataType(ptr, i, paramvalues[i],
      NI_ParamList[index].datatype, NI_ParamList[index].IsComplex);
    i++;
  }

  WriteSideDirtyFlag = 1;
  return retval;
}

/*========================================================================*
 * Function: NIRT_SetScalarParameterInline
 *
 * Abstract:
 *	Sets the value to a parameter immediately without the need of a commit request.
 *
 * Input Parameters:
 *	index		: index of the parameter as returned by NIRT_GetParameterSpec()
 *	subindex	: offset of the element within the parameter
 *	paramvalue	: Value to set the parameter to
 *
 * Returns:
 *	NI_OK if no error
 *========================================================================*/
DLL_EXPORT int32_t NIRT_SetScalarParameterInline( uint32_t index, uint32_t
  subindex, double paramvalue)
{
  char* ptr = NULL;
  if (index >= (uint32_t)NI_ParamListSize) {
    SetSITErrorMessage("Parameter index is out of bounds.", 1);
    return NI_SetParamTxStatus = NI_ERROR;
  }

  // verify that subindex is within bounds.
  if (subindex >= (uint32_t)NI_ParamList[index].width) {
    SetSITErrorMessage("Parameter subindex is out of bounds.", 1);
    return NI_SetParamTxStatus = NI_ERROR;
  }

  /* Get the parameter's address into the Parameter struct
     casting to char to perform pointer arithmetic using the byte offset */
  ptr = (char *)(&rtParameter[READSIDE]) + NI_ParamList[index].addr;
  ReadSideDirtyFlag = 1;

  /* Convert the incoming double datatype to the parameter's internal datatype and update value */
  return NIRT_SetValueByDataType(ptr, subindex, paramvalue, NI_ParamList[index].
    datatype, NI_ParamList[index].IsComplex);
}

/*========================================================================*
 * Function: NIRT_GetParameter
 *
 * Abstract:
 *	Get the current value of a parameter.
 *
 * Input Parameters:
 *	index	: index of the parameter
 *	subindex: element index into the flattened array if an array
 *
 * Output Parameters:
 *	val		: value of the parameter
 *
 * Returns:
 *	NI_OK if no error
 *========================================================================*/
DLL_EXPORT int32_t NIRT_GetParameter(int32_t index, int32_t subindex, double
  *value)
{
  char* ptr = NULL;

  /* Check index boundaries */
  if (index >= NI_ParamListSize || index < 0 || (subindex>=NI_ParamList[index].
       width)) {
    return NI_ERROR;
  }

  /* Get the parameter's address into the Parameter struct
     casting to char to perform pointer arithmetic using the byte offset */
  ptr = (char *)(&rtParameter[READSIDE]) + NI_ParamList[index].addr;

  /* Convert the parameter's internal datatype to double and return its value */
  *value = NIRT_GetValueByDataType(ptr, subindex, NI_ParamList[index].datatype,
    NI_ParamList[index].IsComplex);
  return NI_OK;
}

/*========================================================================*
 * Function: NIRT_GetVectorParameter
 *
 * Abstract:
 *	Get the current value of a vector parameter.
 *
 * Input Parameters:
 *	index: index of the parameter
 *	paramLength: length of the parameter
 *
 * Output Parameters:
 *	paramValues: an array of the parameter's value
 *
 * Returns:
 *	NI_OK if no error
 *========================================================================*/
DLL_EXPORT int32_t NIRT_GetVectorParameter(uint32_t index, double* paramvalues,
  uint32_t paramlength)
{
  char* ptr = NULL;
  uint32_t i = 0;
  if (index >= (uint32_t)NI_ParamListSize || index < 0 || (paramlength !=
       (uint32_t)NI_ParamList[index].width)) {
    return NI_ERROR;
  }

  /* Get the parameter's address into the Parameter struct
     casting to char to perform pointer arithmetic using the byte offset */
  ptr = (char *)(&rtParameter[READSIDE]) + NI_ParamList[index].addr;
  while (i<paramlength) {
    /* Convert the parameter's internal datatype to double and return its value */
    paramvalues[i] = NIRT_GetValueByDataType(ptr, i, NI_ParamList[index].
      datatype, NI_ParamList[index].IsComplex);
    i++;
  }

  return NI_OK;
}

/*========================================================================*
 * Function: NIRT_GetSimState
 *
 * Abstract:
 *
 * Returns:
 *	NI_OK if no error
 *========================================================================*/
DLL_EXPORT int32_t NIRT_GetSimState(int32_t* numContStates, char
  * contStatesNames, double* contStates, int32_t* numDiscStates, char
  * discStatesNames, double* discStates, int32_t* numClockTicks, char
  * clockTicksNames, int32_t* clockTicks)
{
  int32_t count = 0;
  int32_t idx = 0;
  if ((numContStates != NULL) && (numDiscStates != NULL) && (numClockTicks !=
       NULL)) {
    if (*numContStates < 0 || *numDiscStates < 0 || *numClockTicks < 0) {
      *numContStates = 21;
      *numDiscStates = 598;
      *numClockTicks = NUMST - TID01EQ;
      return NI_OK;
    }
  }

  if ((contStates != NULL) && (contStatesNames != NULL)) {
    idx = 0;
    contStates[idx] = NIRT_GetValueByDataType(&(ctrl_custom_X.Integrator_CSTATE),
      0, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType(&(ctrl_custom_X.Integrator_CSTATE),
      1, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType(&(ctrl_custom_X.Integrator_CSTATE),
      2, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType(&(ctrl_custom_X.Integrator2_CSTATE),
      0, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator2_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType(&(ctrl_custom_X.Integrator2_CSTATE),
      1, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator2_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType(&(ctrl_custom_X.Integrator2_CSTATE),
      2, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator2_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType
      (&(ctrl_custom_X.Integrator2_CSTATE_k), 0, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator2_CSTATE_k");
    contStates[idx] = NIRT_GetValueByDataType
      (&(ctrl_custom_X.Integrator2_CSTATE_k), 1, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator2_CSTATE_k");
    contStates[idx] = NIRT_GetValueByDataType
      (&(ctrl_custom_X.Integrator2_CSTATE_k), 2, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator2_CSTATE_k");
    contStates[idx] = NIRT_GetValueByDataType(&(ctrl_custom_X.Integrator1_CSTATE),
      0, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator1_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType(&(ctrl_custom_X.Integrator1_CSTATE),
      1, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator1_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType(&(ctrl_custom_X.Integrator1_CSTATE),
      2, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator1_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType
      (&(ctrl_custom_X.Integrator1_CSTATE_c), 0, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator1_CSTATE_c");
    contStates[idx] = NIRT_GetValueByDataType
      (&(ctrl_custom_X.Integrator1_CSTATE_c), 1, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator1_CSTATE_c");
    contStates[idx] = NIRT_GetValueByDataType
      (&(ctrl_custom_X.Integrator1_CSTATE_c), 2, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator1_CSTATE_c");
    contStates[idx] = NIRT_GetValueByDataType
      (&(ctrl_custom_X.Integrator1_CSTATE_b), 0, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator1_CSTATE_b");
    contStates[idx] = NIRT_GetValueByDataType
      (&(ctrl_custom_X.Integrator1_CSTATE_b), 1, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator1_CSTATE_b");
    contStates[idx] = NIRT_GetValueByDataType
      (&(ctrl_custom_X.Integrator1_CSTATE_b), 2, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator1_CSTATE_b");
    contStates[idx] = NIRT_GetValueByDataType
      (&(ctrl_custom_X.Integrator_CSTATE_n), 0, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator_CSTATE_n");
    contStates[idx] = NIRT_GetValueByDataType
      (&(ctrl_custom_X.Integrator_CSTATE_n), 1, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator_CSTATE_n");
    contStates[idx] = NIRT_GetValueByDataType
      (&(ctrl_custom_X.Integrator_CSTATE_n), 2, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator_CSTATE_n");
  }

  if ((discStates != NULL) && (discStatesNames != NULL)) {
    idx = 0;
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.UnitDelay1_DSTATE,
      0, 18, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.UnitDelay1_DSTATE");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.UnitDelay1_DSTATE,
      1, 18, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.UnitDelay1_DSTATE");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.UnitDelay1_DSTATE,
      2, 18, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.UnitDelay1_DSTATE");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.bpsi_est_DWORK1, 0,
      0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.bpsi_est_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.bx_est_DWORK1, 0,
      0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.bx_est_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.by_est_DWORK1, 0,
      0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.by_est_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.x_m_DWORK1, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.x_m_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.y_m_DWORK1, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.y_m_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.psi_m_DWORK1, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.psi_m_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&ctrl_custom_DW.QTM_SCOPEPSI_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&ctrl_custom_DW.QTM_SCOPEPSI_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.QTM_SCOPEX_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.QTM_SCOPEX_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.QTM_SCOPEY_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.QTM_SCOPEY_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.psi_d_DWORK1, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.psi_d_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.x_d_DWORK1, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.x_d_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.y_d_DWORK1, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.y_d_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.psi_est_DWORK1, 0,
      0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.psi_est_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.x_est_DWORK1, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.x_est_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.y_est_DWORK1, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.y_est_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.TimeStampA, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.TimeStampA");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.LastUAtTimeA, 0,
      18, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.LastUAtTimeA");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.LastUAtTimeA, 1,
      18, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.LastUAtTimeA");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.LastUAtTimeA, 2,
      18, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.LastUAtTimeA");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.TimeStampB, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.TimeStampB");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.LastUAtTimeB, 0,
      18, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.LastUAtTimeB");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.LastUAtTimeB, 1,
      18, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.LastUAtTimeB");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.LastUAtTimeB, 2,
      18, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.LastUAtTimeB");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.r_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.r_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.u_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.u_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.v_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.v_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.omega_d_DWORK1, 0,
      0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.omega_d_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.u_d_DWORK1, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.u_d_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.v_d_DWORK1, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.v_d_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.r_est_DWORK1, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.r_est_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.u_est_DWORK1, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.u_est_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.v_est_DWORK1, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.v_est_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.alpha_VSP1_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.alpha_VSP1_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.alpha_VSP2_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.alpha_VSP2_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.u_BT_DWORK1, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.u_BT_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.u_VSP1_DWORK1, 0,
      0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.u_VSP1_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.u_VSP2_DWORK1, 0,
      0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.u_VSP2_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.omega_VSP1_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.omega_VSP1_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.omega_VSP2_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.omega_VSP2_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.tau3_DWORK1, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.tau3_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.tau1_DWORK1, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.tau1_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.tau2_DWORK1, 0, 0,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.tau2_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.Freeze_DWORK1, 0,
      0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.Freeze_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&ctrl_custom_DW.Memory_PreviousInput, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&ctrl_custom_DW.Memory_PreviousInput");
    discStates[idx] = NIRT_GetValueByDataType
      (&ctrl_custom_DW.Memory1_PreviousInput, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&ctrl_custom_DW.Memory1_PreviousInput");
    discStates[idx] = NIRT_GetValueByDataType
      (&ctrl_custom_DW.Memory2_PreviousInput, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&ctrl_custom_DW.Memory2_PreviousInput");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.DPmanual_DWORK1, 0,
      0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.DPmanual_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&ctrl_custom_DW.Memory_PreviousInput_m, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&ctrl_custom_DW.Memory_PreviousInput_m");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.DPmanualOut_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.DPmanualOut_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.L2_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.L2_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.LstickRL_DWORK1, 0,
      0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.LstickRL_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.LstickUD_DWORK1, 0,
      0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.LstickUD_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.R2_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.R2_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&ctrl_custom_DW.Tau_cmd_surge_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&ctrl_custom_DW.Tau_cmd_surge_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&ctrl_custom_DW.Tau_cmd_sway_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&ctrl_custom_DW.Tau_cmd_sway_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.Tau_cmd_yaw_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.Tau_cmd_yaw_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.counter, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.counter");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.eta_frozen, 0, 18,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.eta_frozen");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.eta_frozen, 1, 18,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.eta_frozen");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.eta_frozen, 2, 18,
      0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.eta_frozen");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.eta_mem, 0, 18, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.eta_mem");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.eta_mem, 1, 18, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.eta_mem");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.eta_mem, 2, 18, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.eta_mem");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.Scope2_PWORK, 0,
      24, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.Scope2_PWORK");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.Scope2_PWORK, 1,
      24, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.Scope2_PWORK");
    discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.Scope3_PWORK, 0,
      11, 0);
    strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.Scope3_PWORK");
    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.bpsi_est_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.bpsi_est_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.bx_est_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.bx_est_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.by_est_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.by_est_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.x_m_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.x_m_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.y_m_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.y_m_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.psi_m_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.psi_m_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&ctrl_custom_DW.QTM_SCOPEPSI_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&ctrl_custom_DW.QTM_SCOPEPSI_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&ctrl_custom_DW.QTM_SCOPEX_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&ctrl_custom_DW.QTM_SCOPEX_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&ctrl_custom_DW.QTM_SCOPEY_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&ctrl_custom_DW.QTM_SCOPEY_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.psi_d_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.psi_d_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.x_d_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.x_d_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.y_d_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.y_d_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.psi_est_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.psi_est_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.x_est_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.x_est_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.y_est_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.y_est_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.r_DWORK2, count,
        21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.r_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.u_DWORK2, count,
        21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.u_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.v_DWORK2, count,
        21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.v_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.omega_d_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.omega_d_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.u_d_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.u_d_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.v_d_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.v_d_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.r_est_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.r_est_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.u_est_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.u_est_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.v_est_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.v_est_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&ctrl_custom_DW.alpha_VSP1_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&ctrl_custom_DW.alpha_VSP1_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&ctrl_custom_DW.alpha_VSP2_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&ctrl_custom_DW.alpha_VSP2_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.u_BT_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.u_BT_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.u_VSP1_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.u_VSP1_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.u_VSP2_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.u_VSP2_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&ctrl_custom_DW.omega_VSP1_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&ctrl_custom_DW.omega_VSP1_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&ctrl_custom_DW.omega_VSP2_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&ctrl_custom_DW.omega_VSP2_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.tau3_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.tau3_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.tau1_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.tau1_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.tau2_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.tau2_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.Freeze_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.Freeze_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.DPmanual_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.DPmanual_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&ctrl_custom_DW.DPmanualOut_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&ctrl_custom_DW.DPmanualOut_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.L2_DWORK2, count,
        21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.L2_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.LstickRL_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.LstickRL_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.LstickUD_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.LstickUD_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&ctrl_custom_DW.R2_DWORK2, count,
        21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&ctrl_custom_DW.R2_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&ctrl_custom_DW.Tau_cmd_surge_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&ctrl_custom_DW.Tau_cmd_surge_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&ctrl_custom_DW.Tau_cmd_sway_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&ctrl_custom_DW.Tau_cmd_sway_DWORK2");
    }

    for (count = 0; count < 12; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&ctrl_custom_DW.Tau_cmd_yaw_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&ctrl_custom_DW.Tau_cmd_yaw_DWORK2");
    }

    discStates[idx] = NIRT_GetValueByDataType
      (&ctrl_custom_DW.init_flag_not_empty, 0, 8, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&ctrl_custom_DW.init_flag_not_empty");
  }

  if ((clockTicks != NULL) && (clockTicksNames != NULL)) {
    clockTicks[0] = S->Timing.clockTick0;
    strcpy(clockTicksNames, "clockTick0");
  }

  return NI_OK;
}

/*========================================================================*
 * Function: NIRT_SetSimState
 *
 * Abstract:
 *
 * Returns:
 *	NI_OK if no error
 *========================================================================*/
DLL_EXPORT int32_t NIRT_SetSimState(double* contStates, double* discStates,
  int32_t* clockTicks)
{
  int32_t count = 0;
  int32_t idx = 0;
  if (contStates != NULL) {
    idx = 0;
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator_CSTATE), 0,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator_CSTATE), 1,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator_CSTATE), 2,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator2_CSTATE), 0,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator2_CSTATE), 1,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator2_CSTATE), 2,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator2_CSTATE_k), 0,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator2_CSTATE_k), 1,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator2_CSTATE_k), 2,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator1_CSTATE), 0,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator1_CSTATE), 1,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator1_CSTATE), 2,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator1_CSTATE_c), 0,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator1_CSTATE_c), 1,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator1_CSTATE_c), 2,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator1_CSTATE_b), 0,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator1_CSTATE_b), 1,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator1_CSTATE_b), 2,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator_CSTATE_n), 0,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator_CSTATE_n), 1,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&(ctrl_custom_X.Integrator_CSTATE_n), 2,
      contStates[idx++], 0, 0);
  }

  if (discStates != NULL) {
    idx = 0;
    NIRT_SetValueByDataType(&ctrl_custom_DW.UnitDelay1_DSTATE, 0, discStates[idx
      ++], 18, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.UnitDelay1_DSTATE, 1, discStates[idx
      ++], 18, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.UnitDelay1_DSTATE, 2, discStates[idx
      ++], 18, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.bpsi_est_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.bx_est_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.by_est_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.x_m_DWORK1, 0, discStates[idx++], 0,
      0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.y_m_DWORK1, 0, discStates[idx++], 0,
      0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.psi_m_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.QTM_SCOPEPSI_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.QTM_SCOPEX_DWORK1, 0, discStates[idx
      ++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.QTM_SCOPEY_DWORK1, 0, discStates[idx
      ++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.psi_d_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.x_d_DWORK1, 0, discStates[idx++], 0,
      0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.y_d_DWORK1, 0, discStates[idx++], 0,
      0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.psi_est_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.x_est_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.y_est_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.TimeStampA, 0, discStates[idx++], 0,
      0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.LastUAtTimeA, 0, discStates[idx++],
      18, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.LastUAtTimeA, 1, discStates[idx++],
      18, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.LastUAtTimeA, 2, discStates[idx++],
      18, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.TimeStampB, 0, discStates[idx++], 0,
      0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.LastUAtTimeB, 0, discStates[idx++],
      18, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.LastUAtTimeB, 1, discStates[idx++],
      18, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.LastUAtTimeB, 2, discStates[idx++],
      18, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.r_DWORK1, 0, discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.u_DWORK1, 0, discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.v_DWORK1, 0, discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.omega_d_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.u_d_DWORK1, 0, discStates[idx++], 0,
      0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.v_d_DWORK1, 0, discStates[idx++], 0,
      0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.r_est_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.u_est_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.v_est_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.alpha_VSP1_DWORK1, 0, discStates[idx
      ++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.alpha_VSP2_DWORK1, 0, discStates[idx
      ++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.u_BT_DWORK1, 0, discStates[idx++], 0,
      0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.u_VSP1_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.u_VSP2_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.omega_VSP1_DWORK1, 0, discStates[idx
      ++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.omega_VSP2_DWORK1, 0, discStates[idx
      ++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.tau3_DWORK1, 0, discStates[idx++], 0,
      0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.tau1_DWORK1, 0, discStates[idx++], 0,
      0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.tau2_DWORK1, 0, discStates[idx++], 0,
      0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.Freeze_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.Memory_PreviousInput, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.Memory1_PreviousInput, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.Memory2_PreviousInput, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.DPmanual_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.Memory_PreviousInput_m, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.DPmanualOut_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.L2_DWORK1, 0, discStates[idx++], 0,
      0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.LstickRL_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.LstickUD_DWORK1, 0, discStates[idx++],
      0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.R2_DWORK1, 0, discStates[idx++], 0,
      0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.Tau_cmd_surge_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.Tau_cmd_sway_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.Tau_cmd_yaw_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.counter, 0, discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.eta_frozen, 0, discStates[idx++], 18,
      0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.eta_frozen, 1, discStates[idx++], 18,
      0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.eta_frozen, 2, discStates[idx++], 18,
      0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.eta_mem, 0, discStates[idx++], 18, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.eta_mem, 1, discStates[idx++], 18, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.eta_mem, 2, discStates[idx++], 18, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.Scope2_PWORK, 0, discStates[idx++],
      24, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.Scope2_PWORK, 1, discStates[idx++],
      24, 0);
    NIRT_SetValueByDataType(&ctrl_custom_DW.Scope3_PWORK, 0, discStates[idx++],
      11, 0);
    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.bpsi_est_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.bx_est_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.by_est_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.x_m_DWORK2, count, discStates[idx
        ++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.y_m_DWORK2, count, discStates[idx
        ++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.psi_m_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.QTM_SCOPEPSI_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.QTM_SCOPEX_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.QTM_SCOPEY_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.psi_d_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.x_d_DWORK2, count, discStates[idx
        ++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.y_d_DWORK2, count, discStates[idx
        ++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.psi_est_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.x_est_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.y_est_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.r_DWORK2, count, discStates[idx++],
        21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.u_DWORK2, count, discStates[idx++],
        21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.v_DWORK2, count, discStates[idx++],
        21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.omega_d_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.u_d_DWORK2, count, discStates[idx
        ++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.v_d_DWORK2, count, discStates[idx
        ++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.r_est_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.u_est_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.v_est_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.alpha_VSP1_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.alpha_VSP2_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.u_BT_DWORK2, count, discStates[idx
        ++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.u_VSP1_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.u_VSP2_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.omega_VSP1_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.omega_VSP2_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.tau3_DWORK2, count, discStates[idx
        ++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.tau1_DWORK2, count, discStates[idx
        ++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.tau2_DWORK2, count, discStates[idx
        ++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.Freeze_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.DPmanual_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.DPmanualOut_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.L2_DWORK2, count, discStates[idx++],
        21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.LstickRL_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.LstickUD_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.R2_DWORK2, count, discStates[idx++],
        21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.Tau_cmd_surge_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.Tau_cmd_sway_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 12; count++) {
      NIRT_SetValueByDataType(&ctrl_custom_DW.Tau_cmd_yaw_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    NIRT_SetValueByDataType(&ctrl_custom_DW.init_flag_not_empty, 0,
      discStates[idx++], 8, 0);
  }

  if (clockTicks != NULL) {
    S->Timing.clockTick0 = clockTicks[0];
    S->Timing.clockTick1 = clockTicks[0];
  }

  return NI_OK;
}

#endif                                 // of NI_ROOTMODEL_ctrl_custom
